unit En_Factor;

interface

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ComCtrls, Spin, HyperText;

type

  { TEnFactor }

  TEnFactor = class(TForm)
    HyperText: THyperText;
    Image2: TImage;
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Image1: TImage;
    Label6: TLabel;
    BitBtn1: TBitBtn;
    seLayerNumber: TSpinEdit;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure seLayerNumberChange(Sender: TObject);
  private
    procedure SetProperty_of_EnCurve(layer: Integer; FileName: String);
    procedure ShowEquation;
    procedure GetParameters;
  public
    {
    ExeDir, Slash, MyDocDir: String;
    dialogbox, LANG: Shortint;
    GoAhead: Boolean;
    }
  end;

var
  EnFactor: TEnFactor;
  i, j: Shortint;

implementation

uses
  FigFileMaker, RC_Params, WASH1dMain;

//------------------------------------------------------
procedure TEnFactor.FormCreate(Sender: TObject);
begin
  dialogbox := -1;
  seLayerNumber.Value := 1;
  j := 1;
  seLayerNumber.MaxValue := Soil.NumLayer;
  if Soil.NumLayer = 1 then
    seLayerNumber.Enabled := False;
 ExeDir := ExtractFileDir(Application.ExeName);
 {$ifdef Linux}
  Slash := '/';
 {$else}
  Slash := '\';
 {$endif}
  ShowEquation;
end;
//------------------------------------------------------
procedure TEnFactor.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close();
end;
//------------------------------------------------------
procedure TEnFactor.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=6; Close();
end;
//------------------------------------------------------
procedure TEnFactor.NextClick(Sender: TObject);
begin
  GoAhead:=true; dialogbox:=8; Close();
end;
//------------------------------------------------------
procedure TEnFactor.ShowEquation;
var
  y: array[0..4] of Integer;
  i: Integer;
begin
  dumstr:='McInnes_en0.png';
  if j = 0 then j := 1;
  Edit1.Text := FloatToStr(Soil.Aen[j]);
  Edit2.Text := FloatToStr(Soil.Ben[j]);
  Edit3.Text := FloatToStr(Soil.Cen[j]);
  Edit5.Text := FloatToStr(Soil.Een[j]);
  dumstr := ExeDir + Slash + 'Equations' + Slash + dumstr;
  image1.picture.loadfromfile(dumstr);
  HyperText.TargetCanvas := Image2.Canvas;
  Image2.Canvas.Brush.Color := Self.Color;
  Image2.Canvas.FillRect(Rect(0, 0, Image2.Width, Image2.Height));
  y[0] := 0;
  for i := 1 to 4 do
    y[i] := y[i-1] + 30;
  with HyperText do
  begin
    Write('[5][r][i]a[_]e[-][/i] = ', 0, y[0], 0);
    Write('[i]b[_]e[-][/i] = ', 0, y[1], 0);
    Write('[i]c[_]e[-][/i] = ', 0, y[2], 0);
    Write('[i]d[_]e[-][/i] = ', 0, y[3], 0);
    Write('[i]e[_]e[-][/i] = ', 0, y[4], 0);
  end;
end;
//------------------------------------------------------
procedure TEnFactor.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;

procedure TEnFactor.BitBtn1Click(Sender: TObject);
begin
  GetParameters;
  if Soil.Mode = 2 then
    i := 1
  else
    i := j;
  SetProperty_of_EnCurve(i, Soil.CaseName + '_En_Curve');
end;

//--------------------------------------------------------------------
procedure TEnFactor.GetParameters;
begin
  if j = 0 then j := 1;
  Soil.Aen[j] := StrToFloat(Edit1.Text);
  Soil.Ben[j] := StrToFloat(Edit2.Text);
  Soil.Cen[j] := StrToFloat(Edit3.Text);
  Soil.Den[j] := StrToFloat(Edit4.Text);
  Soil.Een[j] := StrToFloat(Edit5.Text);
end;
//--------------------------------------------------------------------
procedure TEnFactor.SetProperty_of_EnCurve(layer: Integer; FileName: String);
var
  i : Integer;
  EnCurve : TXYGrapher;
begin
  EnCurve := TXYGrapher.Create;
  j := layer;
  with EnCurve do
  begin
    SetFormSize(550, 500);
    //----------
    NumDataSeries := 1;
    DataSeries[1] := 'a + b * x - (a - d) * exp(-c * x^e)  <> ?';
    Xb[1] := 1; Xt[1] := 0; Yl[1] := 2; Yr[1] := 0; ReadStart[1] := 0; ReadEnd[1] := 0;
    LineStyle[1] := 1; LineWidth[1] := 0.25; LineColor[1] := 8421440; MarkStyle[1] := 0; MarkSize[1] := 0;
    Xmult[1] := 1; Xoffset[1] := 0; Ymult[1] := 1; Yoffset[1] := 0;
    p[j,1] := Soil.Aen[j]; p[j,2] := Soil.Ben[j]; p[j,4] := Soil.Cen[j]; p[j,3] := Soil.Den[j]; p[j,5] := Soil.Een[j] ;
    //---------------------------------
    Height := 65; Width := 65; Lmargin := 30; Tmargin := 20; FLineWidth := 0.4; NumFontSize := 9;
    NumFontName := 'Arial';
    Max[1] := 1 ; Min[1] := 0 ; Division[1] := 5; Minordivision[1] := 2; logarithm[1] := 0; NumeralsXshift[1] := 0; NumeralsYshift[1] := 0; ZeroLine[1] := 0;
    Max[2] := 1 ; Min[2] := 0 ; Division[2] := 5; Minordivision[2] := 2; logarithm[2] := 0; NumeralsXshift[2] := 0; NumeralsYshift[2] := 0; ZeroLine[2] := 0;
    Max[3] := 25; Min[3] := 0; Division[3] := 5; Minordivision[3] := 0; logarithm[3] := 0; NumeralsXshift[3] := 0; NumeralsYshift[3] := 0; ZeroLine[3] := 0;
    Max[4] := 25; Min[4] := 0; Division[4] := 5; Minordivision[4] := 0; logarithm[4] := 0; NumeralsXshift[4] := 0; NumeralsYshift[4] := 0; ZeroLine[4] := 0;
    NumLegend := 5;
    for i := 2 to 5 do
      Legend[i] := Msg[i+32];
    Legend[1] := Msg[33] + Soil.SoilName[j] + '\n';
    LegendLspacing[1] := 4; LegendXshift[1] := 0; LegendYshift[1] := 0;
    SaveFigFile(FileName);
    ExecuteXYGrapher(FileName);
  end;
  EnCurve.Free;
end;

procedure TEnFactor.seLayerNumberChange(Sender: TObject);
begin
  if (Edit1.Text <> '1') or (Edit2.Text <> '1') then
  begin
    GetParameters;
    j := seLayerNumber.Value;
    ShowEquation;
  end;
end;


Initialization
{$I En_Factor.lrs}
end.
