unit I_Information;

interface

//{$define testing}

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, Spin, IniFiles, Math;

type

  { TInverseInfo }

  TInverseInfo = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    cbType: TComboBox;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    chkRetCurve: TCheckBox;
    chkAddRetData: TCheckBox;
    Select1: TBitBtn;
    Select2: TBitBtn;
    Select3: TBitBtn;
    Select4: TBitBtn;
    Next: TButton;
    Back: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Panel3: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    lblNumsensor: TLabel;
    Edit12: TEdit;
    Select5: TBitBtn;
    chkAddHyConData: TCheckBox;
    seNumSensor: TSpinEdit;
    chkOutlow: TCheckBox;
    CheckBox5: TCheckBox;
    Label6: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    Bevel1: TBevel;
    procedure Edit1Change(Sender: TObject);
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbTypeChange(Sender: TObject);
    procedure chkAddRetDataClick(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Select3Click(Sender: TObject);
    procedure Select4Click(Sender: TObject);
    procedure Select2Click(Sender: TObject);
    procedure chkAddHyConDataClick(Sender: TObject);
    procedure Language;
    procedure Help1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Select5Click(Sender: TObject);
    procedure seNumSensorChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure chkOutlowClick(Sender: TObject);
    procedure chkRetCurveClick(Sender: TObject);
  private
    AllowChangeLanguage: Boolean;

  public
  end;

var
  InverseInfo: TInverseInfo;

implementation

uses
  WASH1dMain, StringGrid, Recent, RC_Params, K_Params;

//--------------------------------------------------------------
procedure TInverseInfo.FormShow(Sender: TObject);
begin
  DialogBox := -1;
  AllowChangeLanguage := False;
  seNumSensor.Value := Tensio;
//  seNumSensorChange(Sender);
  cbType.ItemIndex := IPET_type - 1;
  chkRetCurve.Checked := (independent = 1);
  case IPET_type of
  1:begin
      chkOutlow.Checked := (UseOutFlowForK = 1);
      chkAddHyConData.Checked := (UseAdditionalHyConData = 1);
    end;
  2:begin
      chkOutlow.Checked := (UseOutFlowForK = 1);
      CheckBox5.Checked := ((l_bc_type = 4) and (UseOutFlowForK = 0));
    end;
  end;
  chkAddRetData.Checked := ((AddRetData  = 1) or (IPET_type = 1));
  cbTypeChange(Sender);
  chkAddRetDataClick(Sender);
  chkAddHyConDataClick(Sender);
  seNumSensorChange(Sender);
  AllowChangeLanguage := True;
  Language;
  dumint := 9999;
  Select2.Glyph := Select1.Glyph;
  Select3.Glyph := Select1.Glyph;
  Select4.Glyph := Select1.Glyph;
  Select5.Glyph := Select1.Glyph;
end;

procedure TInverseInfo.cbTypeChange(Sender: TObject);
begin
  IPET_type := cbType.ItemIndex + 1;
  Edit2.Visible  := False;
  Edit7.Visible  := False;
  Edit1.Left := 212;
  chkAddHyConData.Visible := True;
  chkRetCurve.Enabled := True;
  lblNumsensor.Caption := 'Number of tensiometers';
  Panel3.Top := 286;
  Panel1.Top := 136;
  chkAddRetData.Visible := True;
  fl_outflow := TrimLeft(fl_outflow);
  case IPET_Type of
    1:begin  // TSM
        fl_clmtc_con := TrimLeft(fl_clmtc_con);
       // if (fl_CumEvap = '') and (dumint = 9999) then Select2Click(sender);
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_clmtc_con);
        Label1.Visible := False;
        Label4.Visible := True;
        Label5.Visible := True;
        Edit1.Visible  := False;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        Edit6.Visible  := True;
        seNumSensor.Enabled := False;
        Select2.Enabled := True;
        CheckBox5.Enabled := False;
        lblNumsensor.Enabled := False;
        Label4.Enabled := True;
        Label5.Visible := True;
        fl_profile := TrimLeft(fl_profile);
        {
        if (fl_profile = '') and (dumint = 9999) then
          Select3Click(sender);
        }
        Edit5.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
        fl_retention := TrimLeft(fl_retention);
        {
        if (fl_retention = '') and (dumint = 9999) then
          Select4Click(Sender);
        }
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        chkAddRetData.Checked := True;
        chkAddRetData.Enabled := True;
        chkAddHyConData.Enabled := True;
        chkRetCurve.Enabled := False;
      //  Panel3.Top := 265;
        Panel1.Top := Panel2.Height + chkAddHyConData.Top + chkAddHyConData.Height + 20;
        Solute := True;
      end;
    2:begin // MSO
        Label1.Visible := True;
        lblNumsensor.Visible := True;
        Label4.Visible := True;
        Label5.Visible := False;
        seNumSensor.Visible := True;
        Edit1.Visible  := True;
        Edit4.Visible   := True;
        Edit5.Visible  := False;
        Edit6.Visible  := False;
        chkRetCurve.Enabled := True;
        chkAddRetData.Visible := True;
        chkAddHyConData.Enabled := False;
        Edit1.Text := FloatToStr(W_end);
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        if Tensio > 0 then
          Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_pressure);
        {$ifdef testing}
        Panel3.Top := 287;
        {$else}
        Panel3.Top := 215;
        {$endif}
        HelpContext := 13;
        Panel1.Top := Panel2.Height + chkAddRetData.Top + chkAddRetData.Height + 20;
      end;
    3:begin // MSI //
        Label1.Visible := True;
        lblNumsensor.Visible := True;
        Label4.Visible := True;
        Label5.Visible := True;
        seNumSensor.Enabled := False;
        seNumSensor.Value := 0;
        Edit1.Visible  := True;
        Edit2.Visible  := True;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        Edit6.Visible  := False;
        Edit7.Visible  := True;
        chkRetCurve.Enabled := False;
        chkRetCurve.Checked := True;
        chkAddRetData.Checked := True;
        chkAddRetData.Enabled := False;
        chkAddHyConData.Visible := False;
        Panel3.Top := 145;
        Label6.Top := Label1.Top - 25;
        Label7.Top := Label6.Top;
        Edit2.Top  := Edit1.Top - 25;
        Edit7.Top  := Edit2.Top;
        Edit1.Left := 275;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        Edit1.Text := FloatToStr(t_slicing);
        Edit2.Text := FloatToStr(z_slice);
        Edit7.Text := FloatToStr(W_slice);
        HelpContext := 13;
        Panel1.Top := Panel3.Top + Edit1.Top + Edit1.Height + 20;
      end;
    4:begin  // EMwT
        seNumSensor.Visible := True;
        if seNumSensor.Value = 0 then
          seNumSensor.Value := 1;
        seNumSensor.MinValue := 1;
        lblNumsensor.Visible := True;
        Label5.Visible := True;
        Edit2.Visible  := True;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        chkRetCurve.Enabled := True;
       // chkAddRetData.Enabled := False;
        chkAddHyConData.Enabled := False;
        chkOutlow.Visible := False;
        CheckBox5.Enabled := True;
        Panel3.Top := Panel2.Top + Edit5.Top + Edit5.Height + 4;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_pressure);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_clmtc_con);
        if ExtractFileName(fl_profile) = '' then
          Edit1.Text := FloatToStr(W_end)
        else
          Edit5.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
        Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
        Label6.Caption := 'Duration for ra determination';
        Edit2.Text := FloatToStr(duration_ra / t_unit);
        Label1.Top := Label6.Top - 30;
        Soil.cbRF.ItemIndex := 1;
        Soil.cbRF.Enabled := False;
        HelpContext := 12;
        Solute := True;
        Panel1.Top := Panel3.Top + Label6.Top + Label6.Height + 20;
      end;
    5:begin  // UIM ///
        seNumSensor.Visible := False;
        lblNumsensor.Visible := False;
        Label4.Visible := True;
        Label5.Visible := True;
        Edit4.Visible  := True;
        Edit5.Visible  := True;
        chkRetCurve.Enabled := True;
        chkAddRetData.Enabled := False;
        chkAddHyConData.Enabled := False;
        chkOutlow.Visible := True;
        Panel3.Top := 265;
        Soil.cbRF.ItemIndex := 1;
        Soil.cbRF.Enabled := False;
        //Kparams.cbKF.ItemIndex := 2;
        //Kparams.cbKF.Enabled := False;
        HelpContext := 12;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_front);
        if UseProfileForK = 1 then
        begin
          Edit5.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
          chkOutlow.Checked := True;
        end
        else
        begin
          chkOutlow.Checked := False;
          Select3.Enabled := False;
        end;
        if Edit4.Text <> '' then
          chkRetCurve.Checked := True
        else
          chkRetCurve.Checked := False;
        chkRetCurveClick(Sender);
        if Edit5.Text <> '' then
          chkOutlow.Checked := True
        else
          chkOutlow.Checked := False;
        Edit1.Text := FloatToStr(Wfront);
        Panel1.Top := Panel2.Height + chkAddHyConData.Top + chkAddHyConData.Height + 20;
      end;
    6:begin  // Drainage Method using a Lysimeter
        seNumSensor.Visible := True;
        seNumSensor.Value := 1;
        seNumSensor.Enabled := False;
        Label1.Visible := False;
        lblNumsensor.Visible := True;
        Label4.Visible := True;
        Label5.Visible := False;
        Edit1.Visible  := False;
        Edit4.Visible  := True;
        Edit5.Visible  := False;
        Edit6.Visible  := False;
        chkAddRetData.Enabled := False;
        chkAddHyConData.Enabled := False;
        chkOutlow.Visible := False;
        Panel3.Top := 265;
        HelpContext := 12;
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_pressure);
        Panel1.Top := Panel2.Top + Edit4.Top + Edit4.Height + 20;
      end;
 7..8:begin  // Water Content Fitting Method
        fl_clmtc_con := TrimLeft(fl_clmtc_con);
       // if (fl_CumEvap = '') and (dumint = 9999) then Select2Click(sender);
        Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
        chkRetCurve.Enabled := False;
        lblNumsensor.Caption := 'Number of soil moisture probes';
        Label1.Visible := False;
        Label4.Visible := False;
        Label5.Visible := False;
        Edit1.Visible  := False;
        Edit4.Visible  := False;
        Edit5.Visible  := False;
        Edit6.Visible  := False;
        Edit12.Visible  := False;
        chkOutlow.Visible := False;
        seNumSensor.Enabled := True;
        chkAddRetData.Visible := False;
        Panel1.Top := 160;
        //Solute := True;
      end;
  end;
  Select2.Visible := Edit4.Visible;
  Select3.Visible := Edit5.Visible;
  Select4.Visible := Edit6.Visible;
  Select5.Visible := Edit12.Visible;
  Label6.Visible := Edit2.Visible;
  Label7.Visible := Edit7.Visible;
  Height := Panel1.Top + Panel1.Height + 25;
  Language;
end;
//----------------------------------------------------------
procedure TInverseInfo.chkAddRetDataClick(Sender: TObject);
begin
  if (chkAddRetData.Checked = True) or (IPET_Type = 1) then
  begin
    if chkAddRetData.Checked = False then
    begin
      ShowMessage('You must include this data.');
      chkAddRetData.Checked := True;
    end;
    fl_retention := TrimLeft(fl_retention);
   // if (fl_retention = '') and (dumint = 9999) then Select4Click(Sender);
    Edit6.Text := Main.GetRelativeDirectory(BaseDir, fl_retention);
    Edit6.Visible  := True;
    Select4.Visible:= True;
  end
  else
  begin
    Edit6.Visible  := False;
    Select4.Visible:= False;
  end;
end;
//--------------------------------------------------------------
procedure TInverseInfo.Select1Click(Sender: TObject);
begin
  if IPET_Type = 4 then
    Main.SelectFile(fl_pressure, Edit3)
  else
    Main.SelectFile(fl_outflow, Edit3);
end;
//----------------------------------------------------------
procedure TInverseInfo.Select2Click(Sender: TObject);
begin
  case IPET_Type of
    1  : Main.SelectFile(fl_clmtc_con, Edit4);
    2,6: Main.SelectFile(fl_pressure, Edit4);
    4  : begin
           Main.SelectFile(fl_clmtc_con, Edit4);
           Main.SelectFile(fl_profile, Edit5);
           if fl_profile <> '' then
           begin
             Edit1.Text := '';
             Label1.Enabled := False;
           end;
         end;
    5  : Main.SelectFile(fl_front, Edit4);
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Select3Click(Sender: TObject);
begin
  case IPET_type of
  1,4,5: Main.SelectFile(fl_profile, Edit5);
  //2  : Main.SelectFile(fl_p_bot, Edit5)
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Select4Click(Sender: TObject);
begin
  Main.SelectFile(fl_retention, Edit6);
end;
//----------------------------------------------------------
procedure TInverseInfo.chkAddHyConDataClick(Sender: TObject);
begin
  if chkAddHyConData.Checked = True then
  begin
    if IPET_type = 1 then
    begin
      UseAdditionalHyConData := 1;
      Edit12.Text := Main.GetRelativeDirectory(BaseDir, TrimLeft(fl_HyConData));
    end;
    Edit12.Visible  := True;
    Select5.Visible:= True;
  end
  else
  begin
    UseAdditionalHyConData := 0;
    Edit12.Visible  := False;
    Select5.Visible:= False;
  end;
end;
//===============================================================================================================================
procedure TInverseInfo.Language;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
begin
  if not AllowChangeLanguage then
    Exit;
  Msg[1] := 'Name of file which holds time evolution of cumulative outflow';
  Msg[2] := 'Name of file which holds time evolution of cumulative evaporation';
  Msg[3] := 'Name of file which holds final water content profile';
  Msg[4] := 'Name of file which holds time evolution of tensiometer reading';
  Msg[5] := 'Name of file which holds pressure head at the bottom';
  Msg[6] := 'Time when the slicing was performed = ';
  Msg[7] := 'Name of file which holds time evolution of cumulative inflow';
  Msg[8] := 'Thickness of the sliced layer';
  Msg[9] := 'V.W.C. of the sliced layer';
  Msg[10]:= 'Add infiltrating front in the objective function';
  Msg[11]:= 'Add final water content profile in the objective function';
  Msg[12]:= 'V.W.C. of the wetting front =';
  Msg[13]:= 'Name of file which holds time evolution of depth of infiltrating front';
  Msg[14]:= 'Name of file which holds time evolution of pressure head and water content at the same depth';
  Msg[15]:= 'Name of file which holds time evolution of volumetric water content';
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption             := ReadString(S, 'Caption', '');
        CheckBox5.Caption   := ReadString(S, 'CheckBox5.Caption', '');
        Label4.Caption      := ReadString(S, 'Label4.Caption', '');
        Label3.Caption      := ReadString(S, 'Label3.Caption', '');
        Label5.Caption      := ReadString(S, 'Label5.Caption', '');
        lblNumsensor.Caption      := ReadString(S, 'Label2.Caption', '');
        chkRetCurve.Caption   := ReadString(S, 'chkRetCurve.Caption', '');
        chkOutlow.Caption   := ReadString(S, 'CheckBox4.Caption', '');
        Label1.Caption      := ReadString(S, 'Label1.Caption', '');
        Label6.Caption      := ReadString(S, 'Label6.Caption', '');
        Label7.Caption      := ReadString(S, 'Label7.Caption', '');
        chkAddRetData.Caption   := ReadString(S, 'chkAddRetData.Caption', '');
        Execute.Caption     := ReadString(S, 'Execute.Caption', '');
        Next.Caption        := ReadString(S, 'Next.Caption', '');
        Back.Caption        := ReadString(S, 'Back.Caption', '');
        chkAddHyConData.Caption   := ReadString(S, 'CheckBox3.Caption', '');
        i := cbType.ItemIndex;
        cbType.Items.Text := StringReplace(ReadString(S, 'cbType.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
        cbType.ItemIndex := i;
        for i := 1 to 14 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
  case IPET_type of
  1:begin
      Label3.Caption := Msg[1];
      Label4.Caption := Msg[2];
      Label5.Caption := Msg[3];
    end;
  2:begin
      Label3.Caption := Msg[1];
      Label4.Caption := Msg[4];
      Label5.Caption := Msg[5];                                                                
    end;
  3:begin
      Label1.Caption := Msg[6];
      Label3.Caption := Msg[7];
      Label6.Caption := Msg[8];
      Label7.Caption := Msg[9];
    end;
  4:begin
      Label3.Caption := Msg[4];
      Label4.Caption := Msg[2];
      Label5.Caption := Msg[3];
    end;
  5:begin
      chkRetCurve.Caption := Msg[10];
      chkOutlow.Caption := Msg[11];
      Label1.Caption := Msg[12];
      Label3.Caption := Msg[6];
      Label4.Caption := Msg[13];
      Label5.Caption := Msg[3];
    end;
  6:begin
      Label3.Caption := Msg[1];
      Label4.Caption := Msg[14];
    end;
  7..8:begin
         Label3.Caption := Msg[15];
       end;
  end;
  Edit7.Left := Label7.Left + Label7.Width;
  Edit1.Left := Label1.Left + Label1.Width;
  Edit2.Left := Label6.Left + Label6.Width;
end;

//----------------------------------------------------------
procedure TInverseInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0;
  Close;
end;

procedure TInverseInfo.Edit1Change(Sender: TObject);
begin
  if IPET_type = 4 then
  begin
    if Edit1.Text <> '' then
    begin
      Edit4.Text := '';
      Select2.Enabled := False;
      Label1.Enabled := True;
    end
    else
    begin
      Select2.Enabled := True;
    end;
    Label4.Enabled := Select2.Enabled;
  end;
end;

//--------------------------------------------------------------
procedure TInverseInfo.BackClick(Sender: TObject);
begin
  GoAhead := False;
  DialogBox := 1;
  Close;
end;
//--------------------------------------------------------------
procedure TInverseInfo.NextClick(Sender: TObject);
begin
  GoAhead := True;
  DialogBox := 2;
  Close;
end;
//--------------------------------------------------------------
procedure TInverseInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if water then
  begin
    if chkRetCurve.Checked = True then
      independent := 1
    else
      independent:= 0;
    if chkAddRetData.Checked = True then
      AddRetData  := 1
    else
    begin
      fl_retention := '';
      AddRetData := 0;
    end;
    if (IPET_type = 1) or (IPET_type = 4) then
      fl_clmtc_con := Main.GetAbsoluteDirectory(BaseDir, Edit4.Text);
    if chkAddRetData.Checked then
      fl_retention := Main.GetAbsoluteDirectory(BaseDir, Edit6.Text);
    case IPET_Type of
      1: ;
      2,4: if Edit1.Text <> '' then
             W_end := StrToFloat(Edit1.Text)
           else
             W_end := 0;
      5: Wfront := StrToFloat(Edit1.Text);
    end;
    NumObs := Max(NumObs, Tensio);
    if IPET_type < 7 then
      Heat := False;
    case IPET_type of
    1:begin
        independent := 1;
        fl_outflow := Main.GetAbsoluteDirectory(BaseDir, Edit3.Text);
        fl_profile := Main.GetAbsoluteDirectory(BaseDir, Edit5.Text);
        if chkOutlow.Checked then
        begin
          UseOutFlowForK := 1;
          ic_type := 3;
        end
        else
        begin
          UseOutFlowForK := 0;
          ic_type := 1;
          KsatFix := 1;
        end;
      end;
    2:begin
      //  fl_p_bot := Main.GetAbsoluteDirectory(BaseDir, Edit5.Text);
      //  W_end := StrToFloat(Edit1.Text);
        fl_outflow := Main.GetAbsoluteDirectory(BaseDir, Edit3.Text);
        if chkRetCurve.Checked then
          independent := 1
        else
          independent := 0;
        if chkOutlow.Checked then
          UseOutFlowForK := 1
        else
          UseOutFlowForK := 0;
        if (CheckBox5.Checked) or (chkOutlow.Checked) then
          l_bc_type := 4
        else
          l_bc_type := 5;
      end;
      3:begin // MSI //
          t_slicing := StrToFloat(Edit1.Text);
          z_slice   := StrToFloat(Edit2.Text);
          W_slice   := StrToFloat(Edit7.Text);
        end;
      4:begin // EMwT //
          if Edit1.Text <> '' then
            fl_profile := Main.GetAbsoluteDirectory(BaseDir, Edit5.Text);
          duration_ra := StrToFloat(Edit2.Text) * t_unit;
        end;
      5:begin // UIM //
          if not chkRetCurve.Checked then
            fl_front := '';
          if not chkOutlow.Checked then
            fl_profile := '';
        end;
      7..8:begin // WCFM //
             fl_outflow := Main.GetAbsoluteDirectory(BaseDir, Edit3.Text);
             independent := 0;
           end;
    end;
  end;
end;
//----------------------------------------------------------
procedure TInverseInfo.Help1Click(Sender: TObject);
begin
//  Application.HelpCommand(HELP_CONTEXT,00000011);
end;
//----------------------------------------------------------
procedure TInverseInfo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 113 then //F2
    OutflowWeight := StrToFloat(InputBox('Hidden function', 'Magnification of OutFlowWeight', '2'));
  //if Key=112 then Help1Click(Sender);
end;
//----------------------------------------------------------

procedure TInverseInfo.Select5Click(Sender: TObject);
begin
  Main.SelectFile(fl_HyConData, Edit12);
end;

procedure TInverseInfo.seNumSensorChange(Sender: TObject);
begin
  CheckBox5.Enabled := False;
 // CheckBox5.Checked := False;
  Tensio := seNumSensor.Value;
  Case Tensio of
  0..1:
    begin
      if IPET_type = 4 then
      begin
        Label4.Visible := False;
        Edit4.Visible  := False;
        Select2.Visible:= False;
      end;
    end;
  2:begin
      if IPET_type = 2 then
      begin
       // chkOutlow.Checked := True;
        CheckBox5.Enabled := True;
        Label4.Visible  := True;
        Edit4.Visible   := True;
        Select2.Visible := True;
      end;
    end;
  end;
 if (Tensio = 0) and (IPET_Type = 2) then
 begin
   Label4.Enabled  := False;
   Select2.Enabled := False;
   chkOutlow.Checked := True;
 end
 else
 begin
   Label4.Enabled  := True;
   Select2.Enabled := True;
 end;
 Language;
end;

procedure TInverseInfo.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked then
    chkOutlow.Checked := False;
end;

procedure TInverseInfo.chkOutlowClick(Sender: TObject);
begin
  if IPET_type = 5 then
    if chkOutlow.Checked = False then
    begin
      Edit5.Text := '';
      Select3.Enabled := False;
    end
    else
      Select3.Enabled := True;
end;

procedure TInverseInfo.chkRetCurveClick(Sender: TObject);
begin
  if IPET_type = 5 then
  begin
    Select2.Enabled := chkRetCurve.Checked;
    Edit1.Visible   := chkRetCurve.Checked;
    Label1.Visible  := chkRetCurve.Checked;
    if chkRetCurve.Checked = False then
      Edit4.Text := '';
  end;
end;

Initialization
{$I I_Information.lrs}
end.
