unit I_s_Information;

interface

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TSoluteInverseInfo = class(TForm)
    Back: TButton;
    Execute: TButton;
    Next: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Select1: TBitBtn;
    Label2: TLabel;
    Edit2: TEdit;
    Select2: TBitBtn;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowParams;
    procedure Select1Click(Sender: TObject);
    procedure Select2Click(Sender: TObject);
  private
    procedure GetParameters;
  public
  end;

var
  SoluteInverseInfo: TSoluteInverseInfo;
  j: Shortint;

implementation

uses
  WASH1dMain, RC_Params;

//----------------------------------------------------------
procedure TSoluteInverseInfo.FormCreate(Sender: TObject);
begin
  dialogbox := -1;
  ShowParams;
end;
//----------------------------------------------------------
procedure TSoluteInverseInfo.ShowParams;
begin
  fl_c_profile := TrimLeft(fl_c_profile);
  fl_profile   := TrimLeft(fl_profile);
  Edit1.Text := Main.GetRelativeDirectory(BaseDir, fl_c_profile);
  Edit2.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
  case t_unit of
      1: Label4.caption := 'cm/s';
     60: Label4.caption := 'cm/min';
   3600: Label4.caption := 'cm/h';
  86400: Label4.caption := 'cm/d';
  end;
  Edit3.Text :=  FloatToStr( - q_irg);
  Edit4.Text :=  FloatToStr(C_ini);
end;
//----------------------------------------------------------
procedure TSoluteInverseInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0;
  Close;
end;
//------------------------------------------------------
procedure TSoluteInverseInfo.BackClick(Sender: TObject);
begin
  GoAhead  := False;
  DialogBox:= 1;
  Close;
end;
//------------------------------------------------------
procedure TSoluteInverseInfo.NextClick(Sender: TObject);
begin
  GoAhead   := True;
  DialogBox := 2;
  Close;
end;
//------------------------------------------------------
procedure TSoluteInverseInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//----------------------------------------------------------
procedure TSoluteInverseInfo.GetParameters;
begin
  q_irg  := - StrToFloat(Edit3.Text);
  ic_type     := 4;
  s_ic_type   := 1;
  u_bc_type   := 1;
  SoilName[1] := 'IPE';
  C_ini := StrToFloat(Edit4.Text);
  if ql_top < 0 then
  begin
    s_u_bc_type := 1;
    s_l_bc_type := 1;
    C_irg := 0;
    C_bot := 1;
  end
  else
  begin
    s_u_bc_type := 1;
    s_l_bc_type := 3;
    C_irg := 1;
    C_bot := 0;
  end;
end;

procedure TSoluteInverseInfo.Select1Click(Sender: TObject);
begin
  Main.SelectFile(fl_c_profile, Edit1);
  IPET_type := 11;
end;

procedure TSoluteInverseInfo.Select2Click(Sender: TObject);
begin
  Main.SelectFile(fl_profile, Edit2);
end;

Initialization
{$I I_s_Information.lrs}
end.
