unit PlantProperties;

interface

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ComCtrls, HyperText;

type

  { TPlant }

  TPlant = class(TForm)
    edDkc: TEdit;
    edEkc: TEdit;
    edZr0: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    Image1: TImage;
    bbRF: TBitBtn;
    Image2: TImage;
    HyperText: THyperText;
    edPm50: TEdit;
    edPm: TEdit;
    edPo50: TEdit;
    edBrt: TEdit;
    edAdrt: TEdit;
    edBdrt: TEdit;
    edCdrt: TEdit;
    edAkc: TEdit;
    edBkc: TEdit;
    edCkc: TEdit;
    edAi: TEdit;
    edBi: TEdit;
    edPlantName: TEdit;
    bbOpen: TBitBtn;
    Label1: TLabel;
    edCumTrIni: TEdit;
    bbRD: TBitBtn;
    bbRDvsCumTr: TBitBtn;
    bbKc: TBitBtn;
    bbLAI: TBitBtn;
    OpenDialog1: TOpenDialog;
    procedure edAkcChange(Sender: TObject);
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bbRFClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bbRDClick(Sender: TObject);
    procedure bbRDvsCumTrClick(Sender: TObject);
    procedure bbKcClick(Sender: TObject);
    procedure bbOpenClick(Sender: TObject);
  private
    procedure GetParameters;
  public
    VirtualFile : String;
    procedure LoadProperties;
    procedure SaveProperties(WriteOnFile: Boolean);
  end;

var
  Plant: TPlant;

implementation

uses
  WASH1dMain, RC_Params;

//------------------------------------------------------
procedure TPlant.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close();
end;

procedure TPlant.edAkcChange(Sender: TObject);
begin

end;

//------------------------------------------------------
procedure TPlant.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=10; Close();
end;
//------------------------------------------------------
procedure TPlant.NextClick(Sender: TObject);
begin
  GoAhead:=true;
  if Mode = 3 then
    dialogbox:= 13
  else
    dialogbox:= 0;
  Close;
end;
//------------------------------------------------------
procedure TPlant.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//--------------------------------------------------------------------
procedure TPlant.GetParameters;
begin
  pm50 := StrToFloat(edPm50.Text);
  pm_  := StrToFloat(edPm.Text);
  po50 := StrToFloat(edPo50.Text);
  //po_  := StrToFloat(edPo.Text);
  brt  := StrToFloat(edBrt.Text);
  adrt := StrToFloat(edAdrt.Text);
  bdrt := StrToFloat(edBdrt.Text);
  cdrt := StrToFloat(edCdrt.Text);
  zr0  := StrToFloat(edZr0.Text);
  aKc  := StrToFloat(edAkc.Text);
  bKc  := StrToFloat(edBkc.Text);
  cKc  := StrToFloat(edCkc.Text);
  dKc  := StrToFloat(edDkc.Text);
  eKc  := StrToFloat(edEkc.Text);
  aLAI := StrToFloat(edAi.Text);
  bLAI := StrToFloat(edBi.Text);
  CumTr_ini := StrToFloat(edCumTrIni.Text);
  PlantName := edPlantName.Text;
end;
//--------------------------------------------------------------------

procedure TPlant.FormShow(Sender: TObject);
var
  i: Integer;
  y: array[0..20] of Integer;
begin
  dialogbox := -1;
  y[0] := 10;
  for i := 1 to 20 do
    y[i] := y[0] + Trunc(24.6 * i);
  with HyperText do
  begin
    TargetCanvas := Image1.Canvas;
    Image1.Canvas.Brush.Color := Self.Color;
    Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
    Write('[4][r][i]S[_]root[-][/i] = - [i]T[_]r[-]β[r]α[r]', 10, y[0], 0);
   // Write('[4]α[r][_]w[-][/i] = @[1 + ([i]ψ[r][/i][_][i]m[-] / [i]ψ[r][/i][_][i]m[/i]50[-])[^][i]p[_]m[-][/i]][^]-1[-]', 10, y[1], 0);
   // Write('[4]α[r][_]s[-][/i] = @[1 + ([i]ψ[r][/i][_][i]o[-] / [i]ψ[r][/i][_][i]o[/i]50[-])[^][i]p[_]o[-][/i]][^]-1[-]', 10, y[2], 0);
    Write('[3][r][i]α[/i] = @[1 + ([i][i]ψ ψ[_][/i]50[-][^]-1[-] + [i]ψ[/i][_][i]o[-] [i]ψ[/i][_][i]o[/i]50[-][^]-1[-])[^][i]p[/i][-]][^]-1[-]', 10, y[1], 0);
    Write('[4]β[r] = ([i]b[/i] + 1)[i]d[_]rt[-][^] -[i]b[/i]-1[-]([i]d[_]rt[-] - [i]z[/i] + [i]z[_]r0[-][/i])[^][i]b[/i]', 10, y[5], 0);
    Write('[3][D]β[r][/i] : normalized root density[K]', 10, y[6], 0);
    Write('[4][i]d[_]rt[-] = [i]a[_]drt[-][/i]@[1 - exp([i]b[_]drt[-] [/i][r]Σ[i][r]T[_]r[-][/i])] + [i]c[_]drt[-]', 10, y[7], 0);
    Write('[3][D][i]d[_]rt[-][/i] : lower boundary of the root zone[K]', 10, y[8], 0);
    Write('[4][i]K[_]c[-] = [i]a[_]kc[-][/i]@[1 - exp([i]b[_]kc[-] [/i][i]Σ[r]T[_]r[-][/i])] + [i]c[_]kc[-] - [i]d[_]kc[-][/i]([i]Σ[r]T[_]r[-])[/i][^]ekc[-]', 10, y[11], 0);
    Write('[3][D][i]K[_]c[-][/i] : crop coefficient for transpiration[K]', 10, y[12], 0);
    Write('[4][i]I[/i] = [i]a[_]LAI[-][/i]@[1 - exp([i]b[_]LAI[-] [/i][r]Σ[i][r]T[_]r[-][/i])]', 10, y[16], 0);
    Write('[3][D][i]I[/i] : leaf area index[K]', 10, y[17], 0);
    Write('[4]initial [/i][r]Σ[i][r]T[_]r[-][/i] =', 10, y[20], 0);
    TargetCanvas := Image2.Canvas;
    Image2.Canvas.Brush.Color := Self.Color;
    Image2.Canvas.FillRect(Rect(0, 0, Image2.Width, Image1.Height));
    Write('[4][r]ψ[_][/i]50[-] =', 10, 0, 0);
    Write('[4][i]p[_][-] =', 10     , y[1], 0);
    Write('[4]ψ[/i][_][i]o[/i]50[-] =', 10, y[2], 0);
    Write('[4][i]z[_]r0[-] =',   10, y[4], 0);
    Write('[4][i]b[_]rt[-] =',  10, y[5], 0);
    Write('[4][i]a[_]drt[-] =', 10, y[6], 0);
    Write('[4][i]b[_]drt[-] =', 10, y[7], 0);
    Write('[4][i]c[_]drt[-] =', 10, y[8], 0);
    Write('[4][i]a[_]kc[-] =',  10, y[10], 0);
    Write('[4][i]b[_]kc[-] =',  10, y[11], 0);
    Write('[4][i]c[_]kc[-] =',  10, y[12], 0);
    Write('[4][i]d[_]kc[-] =',  10, y[13], 0);
    Write('[4][i]e[_]kc[-] =',  10, y[14], 0);
    Write('[4][i]a[_]LAI[-] =', 10, y[16], 0);
    Write('[4][i]b[_]LAI[-] =', 10, y[17], 0);
  end;
  edPm50.Text := FloatToStr(pm50);
  edPm.Text   := FloatToStr(pm_);
  edPo50.Text := FloatToStr(po50);
  //edPo.Text   := FloatToStr(po_);
  edBrt.Text  := FloatToStr(brt);
  edAdrt.Text := FloatToStr(adrt);
  edBdrt.Text := FloatToStr(bdrt);
  edCdrt.Text := FloatToStr(cdrt);
  edZr0.Text  := FloatToStr(zr0);
  edAkc.Text  := FloatToStr(aKc);
  edBkc.Text  := FloatToStr(bKc);
  edCkc.Text  := FloatToStr(cKc);
  edDkc.Text  := FloatToStr(dKc);
  edEkc.Text  := FloatToStr(eKc);
  edAi.Text   := FloatToStr(aLAI);
  edBi.Text   := FloatToStr(bLAI);
  edCumTrIni.Text := FloatToStr(CumTr_ini);
  edPlantName.Text := PlantName;
end;

procedure TPlant.bbRFClick(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(10, j);
end;

procedure TPlant.bbRDClick(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(11, j);
end;

procedure TPlant.bbRDvsCumTrClick(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(12, j);
end;

procedure TPlant.bbKcClick(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(13, j);
end;

procedure TPlant.bbOpenClick(Sender: TObject);
begin
  ShowMessage('Please select file containing plant properties.');
  OpenDialog1.InitialDir := ExeDir + Slash + 'PlantProperties';
  OpenDialog1.FileName   := 'Please double-click the file above.';
  if OpenDialog1.Execute = True then
    PlantName := ExtractFileName(ChangeFileExt(OpenDialog1.FileName, ''));
  LoadProperties;
  FormShow(Sender);
end;

procedure TPlant.LoadProperties;
var
  i: Integer;
  f: Textfile;
  Version: Single;
  PropertiesFile, S: String;
  SL: TStringList;

  function NextValue: Double;
  var
    i: Integer;
  begin
    S := TrimLeft(S);
    i := Pos(' ', S);
    if i = 0 then
      i := 100000;
    Result := StrToFloat(Copy(S, 1, i - 1));
    S := Copy(S, i, 100000);
  end;
begin
  Version := 0;
  PropertiesFile := BaseDir + Slash + PlantName + '.dat';
  if FileExists(PropertiesFile) = False then
    PropertiesFile := ExeDir + Slash  + 'PlantProperties' + Slash + PlantName + '.dat';
  if FileExists(PropertiesFile) then
  begin
    SL := TStringList.Create;
    try
      SL.LoadFromFile(PropertiesFile);
      SL.Text := Main.ConvertDecimalSeparator(SL.Text);
      SL.SaveToFile('temp.txt');
    finally
      SL.Free;
    end;
    AssignFile(f, 'temp.txt');
    Reset(f);
    Readln(f, S);
    i := Pos('version', S);
    if i > 0 then
      Version := StrToFloat(Copy(S, i + 7, 4));
    Readln(f, S);
    Readln(f, S);
    Readln(f, S);
    Pm50 := NextValue;
    pm_  := NextValue;
    Po50 := NextValue;
    for i := 1 to 3 do
      Readln(f, S);
    brt  := NextValue;
    adrt := NextValue;
    bdrt := NextValue;
    cdrt := NextValue;
    grt  := NextValue;
    if Version > 0 then
      zr0  := NextValue;
    for i := 1 to 3 do
      Readln(f, S);
    aKc := NextValue;
    bKc := NextValue;
    cKc := NextValue;
    if version >= 2 then
    begin
      dKc := NextValue;
      eKc := NextValue;
    end;
    for i := 1 to 3 do
      Readln(f, S);
    aLAI := NextValue;
    bLAI := NextValue;
    CloseFile(f);
  end;
end;

procedure TPlant.SaveProperties(WriteOnFile: Boolean);
var
  SL: TStringList;
  S: String;
begin
  SL := TStringList.Create;
  try
    with SL do
    begin
      Add('>>>>>>>   Properties of Plant (version 2.2) <<<<<<<');
      Add('====  Stress Response Function  ====');
      Add('  Pm50   pm    Po50   po');
      Add(FloatToStr(Pm50) + '   ' +  FloatToStr(pm_) + '   ' +   FloatToStr(Po50));
      Add('====  Root Density Distribution  ====');
      Add('  brt    adrt    bdrt    cdrt     grt    zr0');
      Add(FloatToStr(brt) + '   ' +  FloatToStr(adrt)  + '   ' +   FloatToStr(bdrt) + '   ' +  FloatToStr(cdrt) + '   ' +  FloatToStr(grt) + '   ' +  FloatToStr(Zr0));
      Add('====  Crop Coefficient  ====');
      Add('  aKc    bKc    cKc    eKc    eKc');
      Add(FloatToStr(aKc) + '   ' +  FloatToStr(bKc)  + '   ' +   FloatToStr(cKc)  + '   ' +   FloatToStr(dKc)  + '   ' +   FloatToStr(eKc));
      Add('====  Leaf Area Index  ====');
      Add('  aLAI   bLAI');
      Add(FloatToStr(aLAI) + '   ' +  FloatToStr(bLAI));
      if WriteOnFile then
      begin
        try
          if not DirectoryExists(BaseDir) then
            CreateDir(BaseDir);
          S := ExeDir + Slash  + 'PlantProperties';
          if not DirectoryExists(S) then
            CreateDir(S);
          SaveToFile(S + Slash + PlantName + '.dat');
        finally
        end;
        SaveToFile(BaseDir + Slash + PlantName + '.dat');
      end
      else
        VirtualFile := SL.Text;
    end
  finally
    SL.Free;
  end;
end;

Initialization
{$I PlantProperties.lrs}
end.
