unit Recent;

interface

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, IniFiles;

type

  { TRecentFile }

  TRecentFile = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    Panel1: TPanel;
    btnOpen: TButton;
    btnOther: TButton;
    btnNew: TButton;
    Label1: TLabel;
    btnAnime: TButton;
    Label2: TLabel;
    StatusBar1: TStatusBar;
    procedure btnOtherClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnNewClick(Sender: TObject);
    procedure btnAnimeClick(Sender: TObject);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    procedure Language;
  public
    function SetLengthLJ(dumstr: String; dumint: Shortint): String;
    procedure SaveRecentFile;
  end;

var
  RecentFile: TRecentFile;
  Msg: array[1..3] of String;

implementation

uses
  WASH1dMain;

 
//----------------------------------------------------------
procedure TRecentFile.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  i, j: Integer;
  f: Textfile;
  S: String;
begin
  Language;
  dumint := 0;
  {$ifdef Linux}
  IniFile := TIniFile.Create(MyDocDir + Slash + '.' + ExtractFileName(ChangeFileExt(Application.ExeName, '.ini')));
  {$else}
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  {$endif}
  try
    if BaseDir = '' then
    begin
      S := IniFile.ReadString('Options', 'CurrentFolder', '');
      BaseDir := Main.GetAbsoluteDirectory(ExeDir, S);
      (*
      if S = '' then
      begin
        BaseDir := MyDocDir;// + Slash + 'WASH_1D';
      //  CreateDir(BaseDir);
        ShowMessage(Msg[1]);
        {$IFDEF Linux}
        S := BaseDir;
        SelectDirectory('Working Directory', '', S);
        BaseDir := S;
        {$else}
        SelectDirectory(BaseDir, [sdAllowCreate, sdPerformCreate, sdPrompt], 1);
        {$endif}
      end;
      *)
    end;
    ListBox1.Items.Clear;
    ListBox2.Items.Clear;
    j := 0;
    for i :=1 to 12 do
      RecentFileName[i] := ''; // initiallization
    for i :=1 to 12 do
    begin
      dumstr :=  IniFile.ReadString('RecentFile', IntToStr(i), '');
      if (Pos(':\', dumstr) = 0) and (StringReplace(dumstr, '..' + Slash, '', [rfReplaceAll]) <> '') then
        dumstr := Main.GetAbsoluteDirectory(ExeDir, dumstr);
      //if i = 1 then
    //  ShowMessage(dumstr);
      if not FileExists(dumstr) then    // for examples
        dumstr := ExeDir + dumstr;
      if (FileExists(dumstr) = True) and (ExtractFileExt(dumstr) = '.in') and (RecentFileName[j] <> dumstr) then
      begin
        j := j + 1;
        RecentFileName[j] := dumstr;
        Assignfile(f, dumstr);
        Reset(f);
        Readln(f,dumstr);
        Readln(f,dumstr);
        Readln(f, RecentComment[j]);
        CloseFile(f);
        dumstr := ExtractFileName(RecentFileName[j]);
        dumstr := Copy(dumstr,1,Length(dumstr)-3);
        ListBox1.Items.Add(SetLengthLJ(dumstr,12));
        ListBox2.Items.Add(RecentComment[j]);
      end;
    end;
  finally
    IniFile.Free;
  end;
//  {$I+}
  if ListBox1.Items.Count > 0 then
    ListBox1.ItemIndex := 0;
  ListBox1Click(Sender);
end;

procedure TRecentFile.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i: Integer;
begin
    if ListBox1.Items.Count > 1 then
  begin
    i := (Y div ListBox1.ItemHeight);
    if i < ListBox1.Items.Count then
      Hint := ListBox1.Items[i];
  end;
end;

//----------------------------------------------------------
procedure TRecentFile.btnOtherClick(Sender: TObject);
begin
  CaseName := '';
  dumint := 0;
  Close;
end;
//----------------------------------------------------------
procedure TRecentFile.btnOpenClick(Sender: TObject);
begin
  dumstr := RecentFileName[ListBox1.ItemIndex+1];
  CaseName := Copy(dumstr,1,Length(dumstr)-3);
  dumint := ListBox1.ItemIndex;
  Close;
end;
//----------------------------------------------------------
procedure TRecentFile.btnNewClick(Sender: TObject);
begin
  CaseName := BaseDir + Slash + 'Untitled';
  dumint := 0;ListBox1.ItemIndex := 0;
  Close;
end;
//----------------------------------------------------------
procedure TRecentFile.btnAnimeClick(Sender: TObject);
begin
  Animation := 1;
  btnOpenClick(Sender);
end;
//----------------------------------------------------------
procedure TRecentFile.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i, j: Integer;
  S: String;
begin
  if dumint > 0 then
  begin
    S := RecentFileName[dumint+1];
    for i:= dumint + 1 downto 2 do
      RecentFileName[i] := RecentFileName[i-1];
    RecentFileName[1] := S;
    S := ExeDir + S;
  end;
  for i := 2 to 12 do
    for j := i-1 downto 1 do
      if RecentFileName[j] = RecentFileName[i] then
        RecentFileName[i] := '';
  SaveRecentFile;
end;
//----------------------------------------------------------
procedure TRecentFile.SaveRecentFile;
var
  IniFile: TIniFile;
  i: Integer;
  S: String;
begin
  IniFile := TIniFile.Create(IniFileName);
  with IniFile do
  try
    for i := 1 to 12 do
    begin
      if RecentFileName[i] <> '' then
      begin
        S := Main.GetRelativeDirectory(ExeDir, RecentFileName[i]);
        WriteString('RecentFile', IntToStr(i), S);
      end;
    end;
  finally
    Free;
  end;
end;

//----------------------------------------------------------
function TRecentFile.SetLengthLJ(dumstr: String; dumint: Shortint): String;
var i: Shortint;
begin
  for i:=1 to dumint - Length(dumstr) do
    dumstr:=dumstr+' ';
  Result := dumstr;
end;
//----------------------------------------------------------

procedure TRecentFile.Language;
var
  IniFile: TIniFile;
  S, S0: String;
  i: Integer;
begin
   //Msg[1] := #13#10 + 'Welcome to WASH_1D!' + #13#10 + #13#10 + 'Please select (or make) the working directory.';//
   //       + #13#10 + 'If you accept the proposed directory in the next dialog box, click on the [OK] button.';
  S := ChangeFileExt(Application.ExeName, '.lng');
  S0 := Self.Name;
  if FileExists(S) then
  begin
    IniFile := TIniFile.Create(S);
    with IniFile do
      try
       // Font.Name        := ReadString(S0, 'Font.Name', '');
        StatusBar1.SimpleText := ReadString(S0, 'StatusBar1.SimpleText', '');
        Label1.Caption   := ReadString(S0, 'Label1.Caption', '');
        Label2.Caption   := ReadString(S0, 'Label2.Caption', '');
        btnOpen.Caption  := ReadString(S0, 'btnOpen.Caption', '');
        btnOther.Caption := ReadString(S0, 'btnOther.Caption', '');
        btnNew.Caption   := ReadString(S0, 'btnNew.Caption', '');
        btnAnime.Caption := ReadString(S0, 'btnAnime.Caption', '');
      //  Font.Size        := ReadInteger(S0, 'Font.Size', 9);
        for i := 1 to 1 do
          Msg[i] := StringReplace(ReadString(S0, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        IniFile.Free;
      end;
  end;
{$ifdef Linux}
  //Locale := GetEnvironmentVariable('LANG');
{$else}
  //Font.Charset := LANG;
{$endif}
//  Label1.Font.Charset := Font.Charset;
//  Label1.Font.Name    := Font.Name;
end;

procedure TRecentFile.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ListBox1Click(Sender);
end;
//----------------------------------------------------------
procedure TRecentFile.ListBox1Click(Sender: TObject);
var dumstr2 : String;
begin
  dumstr  := RecentFileName[ListBox1.Itemindex + 1];
  dumstr  := ExtractFileName(dumstr);
  dumstr  := Copy(dumstr,1,Length(dumstr)-3);
  dumstr2 := ExtractFileDir(RecentFileName[ListBox1.Itemindex + 1]) + Slash + dumstr + '_history.zip';
  dumstr  := ExtractFileDir(RecentFileName[ListBox1.Itemindex + 1]) + Slash + 'History' + Slash + dumstr + '_001.csv';
  if (FileExists(dumstr) = True) or (FileExists(dumstr2) = True) then
    btnAnime.Enabled := True
  else
    btnAnime.Enabled := False;
end;

Initialization
{$I Recent.lrs}
end.
