unit RootFinder;

interface

{$mode delphi}{$H+}
uses 
  Dialogs, SysUtils, Math, Simulation;

function FindRoot(a, b, Accuracy: Double; j, k, FN: Integer; Switch: Boolean): Double;

implementation

function FindRoot(a, b, Accuracy: Double; j, k, FN: Integer; Switch: Boolean): Double;
  var
   // c, c_old, fa, fb: Double;
    c, fa, fc: Double;
    i: Integer;
  function f(x: Double): Double;
  begin
    case FN of
    1: Result := Simulator.GetResidual(x, j);
    2: Result := Simulator.GetScaledParameter(x, j, k, Switch);
    else Result := 0;
    end;
  end;
begin
  fa := f(a);
  //ShowMessage(IntToStr(Ceil(ln(Abs(b - a) / Accuracy) / ln(2))));
  c := 0;
  for i := 1 to Ceil(ln(Abs(b - a) / Accuracy) / ln(2)) do
  begin
    c := (a + b) / 2;
    fc := f(c);
    if fa * fc < 0 then
      b := c
    else
    begin
      a := c;
      fa := fc;
    end;
  end;
  //i := 1;
  {
  c := 10000000000000;
  repeat
    fb := f(b);
    c_old := c;
    c := a - fa * (b - a) / (fb - fa);
    a := b;
    fa := fb;
    b := c;
    //i := i + 1;
  Until Abs(c - c_old) < Accuracy;
  }
 // ShowMessage(IntToStr(i));
  Result := c;
end;

end.
