unit ST_params;

interface

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, HyperText, ComCtrls, Spin;

type

  { TSTparams }

  TSTparams = class(TForm)
    Edit3: TEdit;
    Back: TButton;
    Execute: TButton;
    Next: TButton;
    Panel1: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label6: TLabel;
    seLayerNumber: TSpinEdit;
    HyperText: THyperText;
    Edit4: TEdit;
    Edit5: TEdit;
    Image1: TImage;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowParams;
    procedure seLayerNumberChange(Sender: TObject);
  private
    procedure GetParameters;
  public
    ShowMode: Integer;
  end;

var
  STparams: TSTparams;
  j: Shortint;

implementation

uses
  WASH1dMain, RC_Params;

//----------------------------------------------------------
procedure TSTparams.FormCreate(Sender: TObject);
var x, y: Integer;
begin
  dialogbox := -1;
  seLayerNumber.Value := 1;
  j := 1;
  ShowMode := 0;
  seLayerNumber.MaxValue := NumLayer;
  //if NumLayer = 1 then
  //  seLayerNumber.Enabled := False;
  //dumstr := ExeDir + Slash + 'Equations' + Slash + 'Dispersion params0.png';
 // image1.picture.loadfromfile(dumstr);
  Image1.Canvas.Brush.Color := Self.Color;
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
  x := 160;
  y :=  20;
  HyperText.TargetCanvas := Image1.Canvas;
  with HyperText do
  begin
  //  TargetCanvas.Font.Size := Trunc(StdFontSize * adjuster);
    Write('[3][r][i]D[/i] = [i]D[_]m[-][/i] + [i]D[_]i[-]', x, y, 0);
    Write('D[_]m[-][/i] = λ[r]|[i]V[/i]|'  , x, y + 40, 0);
    Write('[i]D[_]i[-][/i] = [i]D[_]i[/i]0[-]τ[_][r]s[-]'  , x, y + 70, 0);
    Write('τ[r][_]s[-] =  [i]a[_]s[-][/i] {1 - exp@[-([i]b[_]s[-][/i] θ[r])[i][^]cs[-][/i]]} +[i]d[_]s[-][/i]θ[r]'  , x, y + 100, 0);
    Write('λ[r] = ', 54, 160, 0);
    Write('[i]a[_]s[-][/i] = ', 185, 158, 0);
    Write('[i]b[_]s[-][/i] = ', 185, 195, 0);
    Write('[i]c[_]s[-][/i] = ', 305, 158, 0);
    Write('[i]d[_]s[-][/i] = ', 305, 195, 0);
  end;
  ShowParams;
end;
//----------------------------------------------------------
procedure TSTparams.ShowParams;
begin
  if j = 0 then j := 1;
  Edit1.Text := FormatFloat('0.000', Soil.dispersivity[j]);
  Edit2.Text := FloatToStr(Soil.a_tau[j]);
  Edit3.Text := FloatToStr(Soil.b_tau[j]);
  Edit4.Text := FloatToStr(Soil.c_tau[j]);
  Edit5.Text := FloatToStr(Soil.d_tau[j]);
end;
//----------------------------------------------------------
procedure TSTparams.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close();
end;
//------------------------------------------------------
procedure TSTparams.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=4; Close();
end;

procedure TSTparams.FormShow(Sender: TObject);
begin
  if ShowMode = 1 then
  begin
    Back.Enabled := False;
    Next.Enabled := False;
    Execute.Caption := '&OK';
  end
  else
  begin
    Back.Enabled := True;
    Next.Enabled := True;
    Execute.Caption := '&Execute';
 end;
end;

//------------------------------------------------------
procedure TSTparams.NextClick(Sender: TObject);
begin
  GoAhead:=true; dialogbox:=6; Close();
end;
//------------------------------------------------------
procedure TSTparams.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//----------------------------------------------------------
procedure TSTparams.GetParameters;
begin
  if j = 0 then j := 1;
  Soil.dispersivity[j] := StrToFloat(Edit1.Text);
  Soil.a_tau[j]        := StrToFloat(Edit2.Text);
  Soil.b_tau[j]        := StrToFloat(Edit3.Text);
  Soil.c_tau[j]        := StrToFloat(Edit4.Text);
  Soil.d_tau[j]        := StrToFloat(Edit5.Text);
end;

procedure TSTparams.seLayerNumberChange(Sender: TObject);
begin
  if (Edit1.Text <> '1') or (Edit2.Text <> '1') then
  begin
    GetParameters;
    j := seLayerNumber.Value;
    ShowParams;
  end;
end;

Initialization
{$I ST_params.lrs}
end.
