unit S_Information;

interface

{$mode delphi}{$H+}
uses 
  LResources,
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type

  { TSoluteInfo }

  TSoluteInfo = class(TForm)
    edUptakeRatio: TEdit;
    Label13: TLabel;
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    cbIC: TComboBox;
    Edit1: TEdit;
    GroupBox4: TGroupBox;
    lblDs: TLabel;
    ed_Ds: TEdit;
    lbl_Ds_unit: TLabel;
    lbl_V: TLabel;
    ed_V: TEdit;
    lbl_V_unit: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    CBubc: TComboBox;
    Edit2: TEdit;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    CBlbc: TComboBox;
    Edit3: TEdit;
    CBsolute: TComboBox;
    lblSolute: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CheckBox1: TCheckBox;
    BitBtn1: TBitBtn;
    CheckBox2: TCheckBox;
    edCrystal: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Timer1: TTimer;
    procedure CBicChange(Sender: TObject);
    procedure CBubcChange(Sender: TObject);
    procedure CBlbcChange(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure GroupBox3Click(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CBsoluteChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private  }
  public
    { Public  }
  end;

var
  SoluteInfo: TSoluteInfo;

implementation

uses
  WASH1dMain;

 
//----------------------------------------------------------
procedure TSoluteInfo.FormCreate(Sender: TObject);
begin
  dialogbox := -1;
  if not water then
  begin
    lblSolute.Visible := False;
    CBsolute.Visible   := False;
    GroupBox4.Visible := True;
    case t_unit of
        1:dumstr:='s';
       60:dumstr:='min';
     3600:dumstr:='h';
    86400:dumstr:='d';
    end;
    lbl_Ds_unit.Caption := 'cm2/'+dumstr;
    ed_Ds.Text := FloatToStr(Ds);
    lbl_V_unit.Caption := 'cm/'+dumstr;
    ed_V.Text := FloatToStr(q_irg / 0.3);
  end
  else
  begin
    GroupBox4.Visible := False;
    lblSolute.Visible := True;
    CBsolute.Visible   := True;
    CBsolute.ItemIndex := s_type - 1;
    CBsoluteChange(Sender);
  end;
  if (Mode = 2) and ((IPET_type = 1) or (IPET_type = 4)) then
  begin
    s_ic_type := 1;
    s_u_bc_type := 1;
    s_l_bc_type := 3;
    CBic.Enabled  := False;
    CBubc.Enabled := False;
    CBlbc.Enabled := False;
  end;
  if Mode = 3 then
    s_ic_type := 3;
  CBic.ItemIndex  := s_ic_type - 1;
  CBubc.ItemIndex := s_u_bc_type - 1;
  CBlbc.ItemIndex := s_l_bc_type - 1;
  CBicChange(Sender);
  CBubcChange(Sender);
  CBlbcChange(Sender);
  if S_crust = 1 then
    CheckBox1.Checked := True
  else
    CheckBox1.Checked := False ;
  CheckBox2.Checked := CDE_surface_modification;
  edCrystal.Text := FloatToStr(alpha_crys * t_unit);
  edUptakeRatio.Text := FloatToStr(kpu);
  case t_unit of
      1: Label12.caption := '1/s';
     60: Label12.caption := '1/min';
   3600: Label12.caption := '1/h';
  86400: Label12.caption := '1/d';
  end;
end;
//--------------------------------------------------------------
procedure TSoluteInfo.CBicChange(Sender: TObject);
begin
  case CBic.ItemIndex of
    0:begin
        Label2.Caption :='Concentration =' ;
        Label9.caption:='mg/cm3';
        Edit1.Left :=125;
        Edit1.Width :=70;
        Edit1.Text := FloatToStr(c_ini);
        //Edit1.Font.size:= Trunc(9*adjuster);
        BitBtn1.Visible := False;
      end;
    1..2: begin
            Label2.Caption := 'File name';
            Edit1.Left  := 80;
            Edit1.Width := 330;
           // Edit1.Font.size:= Trunc(7*adjuster);
            BitBtn1.Visible := True;
            Edit1.Text := Main.GetRelativeDirectory(BaseDir, fl_iniCprofile);
          end;
  end;
end;
//----------------------------------------------------------
procedure TSoluteInfo.CBubcChange(Sender: TObject);
begin
  case CBubc.ItemIndex of
    0:begin
        s_u_bc_type := 1;
        Label4.Caption := 'Concentration=' ;
        Label5.caption := 'mg/cm3';
        Edit2.Left := 125;
        Edit2.Width := 70;
        Edit2.Text := FloatToStr(C_irg);
      end;
    1:begin
        s_u_bc_type := 2;
        Label4.Caption :='File name';
        Edit2.Left  :=  80;
        Edit2.Width := 330;
        if fl_C_irg = '' then
          Main.SelectFile(fl_C_irg, Edit2)
        else
          Edit2.Text := Main.GetRelativeDirectory(BaseDir,fl_C_irg);
      end;
  end;
end;
//----------------------------------------------------------
procedure TSoluteInfo.CBlbcChange(Sender: TObject);
begin
  case CBlbc.ItemIndex of
    0:begin
        s_l_bc_type := 1;
        Label7.Caption := 'Concentration=' ;
        Label8.caption := 'mg/cm3';
        Edit3.Left  := 125;
        Edit3.Width :=  70;
        Edit3.Text     := FloatToStr(C_bot);
        Label7.Visible := True;
        Label8.Visible := True;
        Edit3.Visible  := True;
      end;
    1:begin
        s_l_bc_type:= 2;
        Label7.Caption := 'File name';
        Edit3.Left := 80;
        Edit3.Width := 330;
        if fl_C_bot ='' then
          Main.SelectFile(fl_C_bot, Edit3)
        else
          Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_C_bot);
        Label7.Visible := True;
        Label8.Visible := False;
        Edit3.Visible  := True;
      end;
    2:begin
        s_l_bc_type := 3;
        Label7.Visible := False;
        Label8.Visible := False;
        Edit3.Visible  := False;
      end;
    end;
end;

procedure TSoluteInfo.Edit1Change(Sender: TObject);
begin
  if CBic.ItemIndex > 0 then
    Timer1.Enabled := True;
end;

//------------------------------------------------------
procedure TSoluteInfo.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close;
end;
//------------------------------------------------------
procedure TSoluteInfo.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=9; Close;
end;

procedure TSoluteInfo.GroupBox3Click(Sender: TObject);
begin

end;

//------------------------------------------------------
procedure TSoluteInfo.NextClick(Sender: TObject);
begin
  GoAhead:=true; dialogbox:=12; Close;
end;
//------------------------------------------------------

procedure TSoluteInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not water then
  begin
    Ds   := StrToFloat(ed_Ds.Text);
    q_irg:= 0.3 * StrToFloat(ed_V.Text);
  end;
  s_ic_type := CBic.ItemIndex + 1;
  if s_ic_type   = 1 then
    C_ini := StrToFloat(Edit1.Text);
  if s_u_bc_type = 1 then
    C_irg := StrToFloat(Edit2.Text);
  if s_l_bc_type = 1 then
    C_bot := StrToFloat(Edit3.Text);
  if CheckBox1.Checked = True then
    S_crust := 1
  else
    S_crust := 0;
  CDE_surface_modification := CheckBox2.Checked;
  alpha_crys := StrToFloat(edCrystal.Text) / t_unit;
  kpu := StrToFloat(edUptakeRatio.Text);
end;
//----------------------------------------------------------
procedure TSoluteInfo.CBsoluteChange(Sender: TObject);
begin
  if CBsolute.ItemIndex > -1 then
    s_type := CBsolute.ItemIndex + 1;
end;

procedure TSoluteInfo.BitBtn1Click(Sender: TObject);
begin
  Main.SelectFile(fl_iniCprofile, Edit1);
end;

procedure TSoluteInfo.Timer1Timer(Sender: TObject);
var S: String;
begin
  Timer1.Enabled := True;
  S := Main.GetAbsoluteDirectory(BaseDir, Edit1.Text);
  if FileExists(S) then
  begin
    fl_iniCprofile := S;
    fl_profile := S;
  end
  else
    Edit1.Text := Main.GetRelativeDirectory(BaseDir, fl_iniCprofile);
  Timer1.Enabled := False;
end;

Initialization
{$I S_Information.lrs}
end.

