{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D

        Copyright(C) 2000-2016 Haruyuki FUJIMAKI
        fujimaki@alrc.tottori-u.ac.jp
        URL: http://www.alrc.tottori-u.ac.jp/fujimaki/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit WASH1dMain;

interface

{$mode delphi}{$H+}
uses 
  LResources,Buttons,
{$ifdef Linux}
  ZipMasterForLinux,
{$else}
  Registry, Windows,
{$endif}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, Math, Printers, ComCtrls,
  ImgList, Output, HyperText, IniFiles, Process;

{$define debugging_}

type

  { TMain }

  TMain = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Open1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Contents1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    OpenDialog2: TOpenDialog;
    Input1: TMenuItem;
    IG: TMenuItem;
    ISP: TMenuItem;
    ISR: TMenuItem;
    ISK: TMenuItem;
    Execute1: TMenuItem;
    ProgressBar1: TProgressBar;
    ISS: TMenuItem;
    IW: TMenuItem;
    IA: TMenuItem;
    ISM: TMenuItem;
    ISH: TMenuItem;
    ISE: TMenuItem;
    Output: TMenuItem;
    ConvertToRate: TMenuItem;
    II: TMenuItem;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    ToolButton6: TToolButton;
    Play_or_Stop: TSpeedButton;
    Rewind: TSpeedButton;
    FastForward: TSpeedButton;
    AnimeCounter: TEdit;
    ToolButton7: TToolButton;
    Slow: TSpeedButton;
    PlayorStop2: TMenuItem;
    Slow2: TMenuItem;
    FastForward2: TMenuItem;
    Rewind2: TMenuItem;
    AnimatedFigure1: TMenuItem;
    IP: TMenuItem;
    ShowObservationFigure: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ShowProfileFigure: TMenuItem;
    HyperText: THyperText;
    OpenDialog3: TOpenDialog;
    tbSaveProfile: TSpeedButton;
    tbStepForward: TSpeedButton;
    tbStepBackward: TSpeedButton;
    IPP: TMenuItem;
    IIRG: TMenuItem;
  //  PrinterSetupDialog1: TPrinterSetupDialog;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Perform(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ManageWizard(Sender: TObject);
    procedure PrintClick(Sender: TObject);
    procedure IGClick(Sender: TObject);
    procedure ISRClick(Sender: TObject);
    procedure ISKClick(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure ISSClick(Sender: TObject);
    procedure IWClick(Sender: TObject);
    procedure IAClick(Sender: TObject);
    procedure ISMClick(Sender: TObject);
    procedure ISHClick(Sender: TObject);
    procedure ISEClick(Sender: TObject);
    procedure ConvertToRateClick(Sender: TObject);
    procedure IIClick(Sender: TObject);
    procedure Play_or_StopClick(Sender: TObject);
    procedure RewindClick(Sender: TObject);
    procedure FastForwardClick(Sender: TObject);
    procedure SlowClick(Sender: TObject);
    procedure AnimatedFigure1Click(Sender: TObject);
    procedure IPClick(Sender: TObject);
    procedure TreatHistoryFile;
    procedure Language;
    procedure Contents1Click(Sender: TObject);
    procedure ShowObservationFigureClick(Sender: TObject);
    procedure ShowProfileFigureClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AnimeCounterDblClick(Sender: TObject);
    procedure SaveInformations(Sender: TObject);
    procedure tbSaveProfileClick(Sender: TObject);
    procedure tbStepForwardClick(Sender: TObject);
    procedure tbStepBackwardClick(Sender: TObject);
    procedure IPPClick(Sender: TObject);
    procedure IIRGClick(Sender: TObject);
  private
    Msg: Array[1..40] of String;
    function  CheckModified: Boolean;
    function  RoundToDecimalSF(Value : Double; SigFig : Integer) : Double;
    function  BoolToStr(V: Boolean): String;
    function  StrToBool(S: String): Boolean;
    procedure SetDefaultValues;
    procedure FileSaveQuery;
    procedure DeleteHistoryFile;
    procedure SaveInFile(WriteOnFile: Boolean);
    procedure GetVirtualFile;
    procedure SetDefaultFont;
    procedure LoadInformations(Sender: TObject);
    procedure Wizard(n: Integer);
  public
    procedure Report;
  //  procedure HyperText.Write(var Img: TImage; OriginalString: String; x, y: Integer);
    procedure Profile;
    procedure DrawProfile(GX, GY : Array of Double; NumPoint: Integer; GXmin: Double; GXmax: Double; Lcol: Integer);
    procedure FluxProfile;
    procedure DrawFluxProfile(var GX : Array of Double; var GY : Array of Double; Lcol: Integer);
    procedure History;
    procedure HistoryDraw(GX, GY : Array of Double; StartPoint, EndPoint: Integer; GYmin, GYmax: Double; Lcol: Integer; PenStyle: TPenStyle);
    procedure DrawProperty;
    procedure ExecuteXYGrapher(XYGrapherMode: Integer; Layer: Integer = 1);
    procedure SendDataToSoil;
    procedure RetrieveDataFromSoil;
    procedure SendDataToKparams;
    procedure RetrieveDataFromKparams;
    procedure SelectFile(var ObjectFileName: String; var ObjectEdit: TEdit);
    function  GetRelativeDirectory(Origin, S: String): String;
    function  GetAbsoluteDirectory(Origin, S: String): String;
    function  ConvertDecimalSeparator(S: String): String;
  end;

const
  True_  ='True';
  False_ ='False';
  PRECISE = 1;
  StephBolz = 0.00000000000567; //W/(cm2K4)
  LOSS = 0;//LOSS = 2;
  NumElem = 501;
  MaxNumObs = 5;
  MaxNumRecord = 6000;
  MaximumMetData = 6000;
  Version = 2.49;

var
  Main: TMain;
  f: textfile;
  CaseName, ExeDir, BaseDir, MyDocDir, dumstr, VirtualFile, Slash, Separator, InifileName: String;
  comment, PlantName, smhd : String;
  SoilName, SoilPropertyFile         :array[0..5] of String;
  fl_ql_top, fl_p_bot: String;
  fl_clmtc_con: String;
  fl_iniCprofile, fl_C_irg, fl_C_bot: String;
  fl_outflow, fl_profile, fl_retention,
  fl_pressure, fl_HyConData, fl_front, JapFont: String;
  fl_c_profile: String;

  dum, dum2: Double;
  dumint : Integer;
  water, solute, heat, GoAhead, FirstExec: boolean;
  Mode, Modified, OriginalModified, JapFontSize: Shortint;
  rec, rec0, IPET_type, StopCalc, ConsiderHysteresis: Shortint;
  DialogBox: shortint;
  ic_type, u_bc_type, l_bc_type, NumLayer, NumObs                             : Shortint;
  t_unit, LoadingStartRow, i_mb                                               : Integer;
  abc_type, h_l_bc_type: Shortint;
  s_ic_type, s_u_bc_type, s_l_bc_type, s_type, S_crust, CRWM: Shortint;
  CDE_surface_modification: Boolean;
  t_c_bot, Cbot, t_c_irg, Cirg                       : array[0..1000] of Double;

  RecentFileName, RecentComment         : array[0..12] of String;
  z                                     : array[-1..NumElem] of Double;
  z_border, z_obs                       : array[0..MaxNumObs] of Double;
  NCtime                                : array[1..MaxNumObs] of Integer;
  z_lb, z_lb0, dz_bot, com_ratio        : Double;
  t_end,dt, dt_ini,dt_max, int_rec                  : Double;
  W_ini, P_ini, P_top_ini, ql_top, q_irg, cum_ql_top, p_bot: Double;
  ra, ra0, rm, RHair, Tair, Tini, Tbot, duration_ra                       : Double;
  Ds, C_ini, C_irg, C_bot                   : Double;
  HC_filter, W_end, Hpond, parlb_a, parlb_b: Double;     // Parameter for Additional Resistance to Lower Boundary
  HC_mb, r_mb, Z_membrane, AEVmembrane, ExponentMembrane: Double;

  // Soil Properties //
  {
  SoilComment                                                               : array[1..5] of String;
  RF                                                                        : array[1..NumElem] of Shortint;
  KF                                                                        : array[1..5] of Shortint;
  Tref, Llambda, LogOfLlambda                              : array[1..5] of Double;
  Wsat, zeta, Wr                                                          : array[1..5] of Double;
  alpha, np, mp, sp, alpha1, np1, alpha2, np2, mp1, mp2          : array[-5..5] of Double;
  Ksat, ak, bk, ck                                                  : array[1..5] of Double;
  a_tau, b_tau, dispersivity                                                : array[1..5] of Double;
  Akh, Bkh, Ckh, Dkh, Ekh, AlbedoMax, AlbedoMin, Aal, Bal, ThickAlb, Aen, Ben, Cen, Den, Een : array[1..5] of Double;
  }
  // In the Simulation //
  dz                                                                        : array[0..NumElem] of Double;
  L                                                                         : array[0..NumElem] of Shortint;
  flx, fly                                                                  : array[0..2000] of Double;

  time_ , avdt: Double;
  IniDay: TDateTime;
  counter, navdt, CRWMcounter: Integer;
  Drawing, AllowRecord, AllowPerform, independent : ShortInt;

  Xmax, Ym, Y0, mean_                                     : array[0..NumElem] of Double;        // for CRWM
  SIGN                                                    : array[0..NumElem] of ShortInt; // for CRWM
  zp                                                      : array[0..40000] of Double; // for CRWM
  ncp                                                     : array[0..40000] of Integer; // for CRWM

  t_clm_con, wv, Ta, RHa, Prcp, Rs, PR, Rg, Tp            : array[0..MaximumMetData] of Double;
  S1, S2: Array[0..MaximumMetData] of String;
  t_p_bot, Pbot, G, t_ql_top, qltop, CumIrrigation        : array[0..2000] of Double;

  n, NumCalc, NCalb, abc_done, Pbot_done, OutFlow_done, NumP, NumPbotData  : Integer;
  qltop_done, Angle: Integer;
  NumCirgData, NumCbotData, Cirg_done, Cbot_done: Integer;
  heatcalc, NegativeDCwarning, ObsPtIrg: Shortint;
  alpha_crys, kpu, cum_s_uptake: Double;
  Cva, Vwind, NumIon, Mweight, Prec, Rshort, Rldown: Double;
  Latitude, DIY, dec_sun, RSD, Jan1, tin_a_day_ini: Double;
  StartDate: TDateTime;
  Walb, Walb_bot, albedo, Rlup, Rl, Rn: Double;
  a_oc, b_oc, c_oc, rsc, ar, br: Double;

  // P1, P2, W1, W2 : Double;
  W_storage_ini, W_storage_new, W_storage_old : Double;
  WCumRError, CumInfilt, CumDrain, CumEvap, CumTr, CumTrp, CumTr_ini, Tr, Trp, ESRErrorW, ESErrorW: Double;
  MaxDiffW, LAI, aLAI, bLAI, Kc, aKc, bKc, cKc, dKc, eKc, adrt, bdrt, cdrt, KRshort, KRl, grt, zr0: Double;
  E_storage_ini, E_storage_old: Double;
  dz_, Diw0, Cmax: Double;
  S_storage_ini, S_storage, Cum_qs_top, Cum_qs_bot, Crystal, SCumRError         : Double;
  MPP, dt_CRWM, dt_CRWM_next, time_CRWM, Vmax , OneStepDisp, OneStepDiff        : Double;  // for CRWM
  Integler_ub, Integler_lb, Vnbefore, V1before                                  : Double;  // for CRWM
  Tnew, maxchangeT, totalLoss : Double;
  ECumRError, E_Storage, CumSHT, CumLHT, CumCHL, CumHLB, CumHLS : Double;
  IniDrying                                                                     : Boolean;
  SL          : TStringList;
  Pm50, Po50, pm_, o_: Double;
  WUE, Pcrop, Pwater, CriticalValue, AutoIrgDepth, IDmax: Double;
  Segments: Boolean = True;

  // Observation //
  time, CumE, CumT, CumD, CumI, Cumqs, ql_bot, Evap, ET, dumArray, t_front, Front, Vr : array[0..MaxNumRecord] of Double;
  Wtime, Ptime, Ctime, Ttime, qltime, qvtime, AvgWaterContentAbove, MassOfSaltAbove     : array[1..MaxNumObs, 0..MaxNumRecord] of Double;

  // Inverse Parameter Estimation //
  t_outflow, t_evaporation, CumOutFlow, CumEvaporation                      : array[0..2000] of Double;
  t_tensio, Ptens1, Ptens2                                           : array[0..2000] of Double;
  Wretm, Pretm, Wkm, LogKm                                                           : array[0..100] of Double;
  Pret, Wret                                                             : array[0..1000] of Double;
  Weight, zm, zmb, zms, Wm, Cm                                 : array[0..100] of Double;
  K_direct, W_direct, K_direct_p, W_direct_p, t_direct, t_direct_p: array[0..1000] of Double;
  MeasuredFront                            : array[0..1000] of Double;
  NumRetData, NumOutflowData, NumEvapData, NumAddRetData, NumSampling, NumFrontData: Integer;
  NumTensioData, NumAddHyConData, NumOutflowData_for_DP                             : Integer;
  NumExp,  AddRetData, FitMode, mfit_for_RF, Tensio, MultiStep : Shortint;
  WsatFix, LlambdaFix, Linked_m, spFix, ZetaFix, WrFix, KsatFix, akFix, bkFix: Shortint;
  UseOutFlowForK, UseProfileForK, UseFrontForK  : Shortint;
  UseAdditionalHyConData, RefillInterval : ShortInt;
  MeanCumOutflow, LowestPbot, ChgCriteria, OutflowWeight: Double;
  ArtSTEOutflow, ArtSTEEvap, ArtCEVWC, ArtCEPsychro: Double;
  t_slicing, z_slice, W_slice, Wfront, Wfc, IrgCapacity, brt, drt : Double;
  Acatchment, Acropping, StorageEfficiency, Vreservoir_max, Vreservoir, LossRate : Double;

  // Graphic //
  Graph, ColumnPosition: ShortInt;
  Moment, Hadjuster, Vadjuster, StdFontSize: Single;

  // Animation //
  Animation, JustLoading, Fast : Shortint;
  Demonstration, playing: Boolean;
  ShowResult : TOutputResults;
  {$ifdef Linux}
  ZipMaster: TZipMasterForLinux;
 // Locale: String;
  {$else}
  //ZipMaster: TZipMaster;
  FCS: Integer;
  {$endif}
  AvFonts: TStringList;

/////////////////////////////////////////////////////////////////
implementation

uses
  Greeting, G_Information, W_Information, RC_Params, K_Params, THC_Params,
  Atmos_BC, Simulation, ST_params, S_Information, Recent, En_Factor,
  I_Information, P_Estimator, Pos_Information, MyMsgDlg,
  Help_Search, I_s_Information, PlantProperties, Irrigation, Reservoir, Membrane;

procedure shell(S: String);
var AProcess: TProcess;
begin
  AProcess := TProcess.Create(nil);
  AProcess.CommandLine := S;
  AProcess.Options := AProcess.Options + [poWaitOnExit];
  AProcess.Execute;
  AProcess.Free;
end;

//---------------------------------------------------------------------------
procedure TMain.FormCreate(Sender: TObject);
var
  Inifile: TIniFile;
  S: String;
  {$ifdef Linux}
  {$else}
  Reg: TRegistry;
  lpBuffer: PChar;
{$endif}
begin
  ExeDir := ExtractFileDir(Application.ExeName);
  {$ifdef Linux}
  MyDocDir := GetEnvironmentVariable('HOME');
  Slash := '/';
  InifileName := MyDocDir + Slash + '.' + ExtractFileName(ChangeFileExt(Application.ExeName, '.ini'));
  FirstExec := not FileExists(InifileName);
  if FirstExec then
  begin
    Shell('cp ' + ChangeFileExt(Application.ExeName, '.ini') + ' ' + InifileName);
  end;
  {$else}
  InifileName := ChangeFileExt(Application.ExeName, '.ini');
  Reg := TRegistry.Create;
  with Reg do
  try
    RootKey := HKEY_CURRENT_USER;
    OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', False);
    MyDocDir := ReadString('Personal');// lpszPath; // Modified 02/01/05
    CloseKey;
  finally
    Free;
  end;
  lpBuffer := AllocMem(256);
  GetWindowsDirectory(lpBuffer, 256);
  S := lpBuffer;
  S := ExtractFileDir(S);
  Slash := '\';
  {$endif}
  {
  IniFile := TIniFile.Create(InifileName);
  try
   /// IniFile.ReadString('Options', 'CurrentFolder', GetRelativeDirectory(ExeDir, BaseDir));
    S := IniFile.ReadString('Options', 'DecimalSeparator', '.');
    if S = '.' then
      DecimalSeparator := '.'
    else
      DecimalSeparator := ',';
  finally
    IniFile.Free;
  end;
  }
  RecentFile:= TRecentFile.Create(Self);
  {
  //-- GreetingBox --//
  Hide;
  GreetingBox := TGreetingBox.create(Self);
  GreetingBox.ShowModal;
  GreetingBox.Release;
  Show;
  }
  SetDefaultValues;
  if DecimalSeparator = '.' then
    Separator := #9
  else
    Separator := #9;
  //RecentFile.Release;
  Timer1.Enabled := True;
  Hadjuster := Screen.Width / 1024.0;
  Vadjuster := Screen.Height / 768.0;
  ProgressBar1.Left  := StatusBar1.Panels[0].Width + 2;
  ProgressBar1.Width := StatusBar1.Panels[1].Width - 2;
  ProgressBar1.Height:= StatusBar1.Height - 2;
  //Font.Assign(RecentFile.Font);
  {$ifdef Linux}
  StdFontSize := 10;//Font.Size;//Trunc(Font.Size * Screen.Width / 800.0);
  {$else}
  StdFontSize := 10;//Font.Size * 120 / GetDeviceCaps(Canvas.Handle, LOGPIXELSY) * (800 / Screen.Width);
  {$endif}
  ShowResult := TOutputResults.Create(Self);
  SL := TStringList.Create;
  Simulator := TSimulator.Create; //(Self);
  {$ifdef Linux}
  ZipMaster := TZipMasterForLinux.Create(Self);
  with ZipMaster do
  begin
    AddOptions := [AddRecurseDirs, AddUpdate];
    ExtrOptions := [ExtrOverWrite, ExtrUpdate];
    {$ifdef MSWINDOWS}
    AddCompLevel := 9;
    Unattended := False;
   // MinZipDllVers := 172;
   // MinUnzDllVers := 172;
   // VersionInfo := '1.72';
    {$endif}
  end;
  {$else}
  //ZipMaster := TZipMaster.Create(Self);
  {$endif}
end;
//---------------------------------------------------------------------------
procedure Tmain.SetDefaultValues;
begin
  {$ifdef MSWINDOWS}
  //ImageList1.GetIcon(5, Application.Icon);
  {$endif}
  MODE := 1; z[1] := 0.5; dz_bot := 2; t_unit := 3600; LoadingStartRow := 1;
  t_end  := 240; int_rec := 0.5;
  ic_type := 1; l_bc_type := 2; u_bc_type := 1;
  IPET_type := 2; independent := 1;
  Tini := 298.2; Tbot := 298.2; Tair := 298.2; RHair := 0.4;
   // ShowObservationFigure.Visible := False;
  NumLayer := 1; NumObs := 1;
  CaseName := BaseDir + Slash + 'Untitled';
  UseOutFlowForK := 1;
  navdt := 1;
  mfit_for_RF := 5;
  OutflowWeight := 1;
  abc_type    := 1; h_l_bc_type := 1; s_type      := 1;
  s_ic_type   := 1; s_u_bc_type := 1; s_l_bc_type := 1;
  HC_filter   := 10;
  HC_mb       := 1;
  Z_membrane  := 0;
  AEVmembrane := -10;
  ExponentMembrane := 3;
  AllowRecord := 1;
  Graph := 0;
  WsatFix := 1; LlambdaFix := 1; spFix := 1; KsatFix := 1;
  ConsiderHysteresis := 1;
  IniDrying := True;
  t_slicing := 0; z_slice := 0; W_slice := 0;
  UseProfileForK := 0; fl_profile := '';
 // parlb_a := 100000;
 // parlb_b := 2;
 // ---- Kuroboku -----
 // parlb_a := 39728208;
 // parlb_b := 3.11;
 // ---- Paddy -----
 // parlb_a := 4055371;
 // parlb_b := 4.49;
  Wfront := 0.05;
  parlb_a := 0;
  parlb_b := 0;
  Angle := 0;
  TargetMaxDiff_logP := 0.01;
  CDE_surface_modification := False;
  alpha_crys := 0.002;
  kpu := 0;
  PlantName := 'Default';
  brt := 1;
  drt := 40;
  Pm50 := -5000;
  Po50 := -5000;
  pm_   := 3;
  //po_   := 3;
  CumTr_ini := 10;
  aLAI := 5;
  bLAI := -0.02;
  aKc  := 1;
  bKc  := -0.1;
  cKc  := 0.1;
  dKc  := 1E-6;
  eKc  := 3;
  adrt := 35;
  bdrt := -0.04;
  cdrt := 5;
  grt := 20;
  zr0 := 2;
  WUE  := 0.001;
  Pcrop:= 0.1;
  Pwater:= 0.0001;
  IniDay := Date;
  ObsPtIrg := 0;
  CriticalValue := 0.02;
  AutoIrgDepth := 1;
  t_ql_top[2] := 0;
  CumIrrigation[1] := 0;
  ql_top := 0.5;
  rm := 0;
  duration_ra := 3600 * 5;
  Acatchment := 10;
  Acropping  := 10;
  StorageEfficiency := 0.8;
  Vreservoir_max := 0;
  Vreservoir := 0;
  LossRate := 0;
  ShortDateFormat := 'yy/mm/dd';
  DateSeparator := '/';
  StartDate := Now;
  Latitude := 0.61086523819801;
  Jan1 := StrToDate('20/1/1');
  //DecimalSeparator := ',';
  RefillInterval := 0;
end;
//----------------------------------------------------------
procedure TMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Application.OnHelp := HelpSearch.HelpTreeView.AppHelp;
  Soil   := TSoil.Create(Self);
  Plant := TPlant.Create(Self);
  RecentFile.ShowModal;
  RecentFile.Release;
  Caption := 'WASH_1D - ' + ExtractFileName(CaseName);
  Language;
  //if CaseName = 'Untitied' then Exit;
  HyperText.DefaultFontSize := 9;
  HyperText.AllowWrite := True;
  Self.Show;
  if Animation = 1 then
  begin
    LoadInformations(Sender);
    if abc_type >= 4 then
      Simulator.LoadClimaticData;
    AnimatedFigure1Click(Sender)
  end
  else
  begin
    if CaseName = BaseDir + Slash + 'Untitled' then
      IGClick(Sender)
    else
    begin
      LoadInformations(Sender);
      ManageWizard(Sender);
    end;
  end;
end;
//----------------------------------------------------------
procedure TMain.FileOpenClick(Sender: TObject);
begin
  FileSaveQuery;
  RecentFile:= TRecentFile.Create(Self);
  SetDefaultValues;
  Timer1Timer(Sender);
  Animation := 0;
  ToolButton4.Enabled := True;
  Execute1.Enabled    := True;
end;
//----------------------------------------------------------
procedure TMain.FileSaveQuery;
begin
  AllowPerform := 1;
  if CheckModified then
  begin
    if Application.MessageBox(PChar(Msg[1]),'', 4) = 6 then
      SaveInformations(Self)
    else
      AllowPerform := 0;
  end;
end;
//----------------------------------------------------------
procedure TMain.LoadInformations(Sender: TObject);
var
  i: Integer;
  Version: Single;
  S: String;

  function ConvertToFullPathName(S: String): String;
  begin
    {$ifdef Linux}
    S := StringReplace(S, '\', '/', [rfReplaceAll]);
    {$else}
    S := StringReplace(S, '/', '\', [rfReplaceAll]);
    {$endif}
    if (S <> '') and (S <> ' ') then
      if Version > 1.22 then
        Result := GetAbsoluteDirectory(BaseDir, S)
      else
        Result := ExeDir + S
    else
      Result := '';
  end;

  function GetString(Key: String): String;
  var i : Integer;
  begin
    Result := '';
    for i := 3 to SL.Count - 1 do
      if Pos(Key, SL.Strings[i]) > 0 then
      begin
        Result := TrimLeft(TrimRight(Copy(SL.Strings[i], Pos('=', SL.Strings[i]) + 1, 255)));
        Break;
      end;
    //if Result = '' then
    //  Result := MyMessageDlg.ReceiveString('Please input the value of ..', Key, '', ' ', 0, 1);
  end;

  function GetIntegerValue(Key: String): Integer ;
  var i : Integer;
  begin
    Result := 1;
    try;
      for i := 3 to SL.Count - 1 do
        if Pos(Key, SL.Strings[i]) > 0 then
        begin
          Result := StrToInt(Copy(SL.Strings[i], Pos('=', SL.Strings[i]) + 1, 255));
          Break;
        end;
    except
      Result := MyMessageDlg.ReceiveInteger('Please input the value of ..', Key, '  ', 1, 30, 1);
    end;
  end;

  function GetFloatValue(Key: String): Double;
  var
    i : Integer;
    S : String;
  begin
    Result := 1;
    try
      for i := 3 to SL.Count - 1 do
        if Pos(Key, SL.Strings[i]) > 0 then
        begin
          S := ConvertDecimalSeparator(Copy(SL.Strings[i], Pos('=', SL.Strings[i]) + 1, 255));
          Result := RoundToDecimalSF(StrToFloat(S), 5);
          Break;
        end;
    except
      Result := MyMessageDlg.ReceiveFloat('Please input the value of ..', Key, ' ', 0, 60, 1);
    end;
  end;

  function IntToBool(n: Integer): Boolean;
  begin
    if n = 0 then
      Result := False
    else
      Result := True;
  end;

begin
  Version := 0;
  Execute1.Enabled := True;
  if CaseName = '' then
  begin
    with OpenDialog1 do
    begin
      InitialDir := BaseDir;
      FileName   := 'Please Double-click the file above.';
      if Execute <> True then
        Exit;
      if ExtractFileExt(FileName) <> '.in' then  // 01/17/00
      begin
        ShowMessage('You can load setting file(*.in) only. Please retry.');
        Exit
      end;
      CaseName := Copy(FileName,1,Length(FileName)-3);
      RecentFile := TRecentFile.Create(Self);
      dumint := 11;
    end;
    //Delete(dumstr, 1, Length(BaseDir));
    RecentFileName[12] := CaseName + '.in';
    RecentFile.Close;
    RecentFile.Release;
  end;
  BaseDir := ExtractFileDir(CaseName);
  SL.Clear;
  SL.LoadFromFile(CaseName + '.in');
  //ShowMessage(SL.Text);
  i := Pos('version', SL[0]);
  if i > 0 then
    Version := StrToFloat(ConvertDecimalSeparator(Copy(SL[0], i + 7, 5)));
  Comment := SL[2];
  MODE   := GetIntegerValue('Mode');
  if Mode = 2 then
  begin
    IPET_type := GetIntegerValue('type of I.P.E.');
    II.Visible := True;
  end;
  if Mode < 3 then
    IIRG.Visible := True
  else
    IIRG.Visible := False;
  if (Version < 1.215) and (IPET_type > 2) then
    IPET_type := IPET_type + 1;
  if Version > 1.961 then
  begin
    Water  := StrToBool(GetString('water'));
    Solute := StrToBool(GetString('solute'));
    Heat   := StrToBool(GetString('heat'));
  end
  else
  begin
    Water  := IntToBool(GetIntegerValue('water'));
    Solute := IntToBool(GetIntegerValue('solute'));
    Heat   := IntToBool(GetIntegerValue('heat'));
  end;
  z_lb   := GetFloatValue('depth of lower boundary');
  z[1]   := GetFloatValue('space increment at the top');
  dz_bot := GetFloatValue('space increment at the bottom');
  NumLayer := GetIntegerValue('number of layer');
  if NumLayer >= 2 then
    for i := 1 to NumLayer - 1 do
      z_border[i] := GetFloatValue('depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + 'border');
  NumObs := GetIntegerValue('number of observation point');
  for i := 1 to NumObs do
    z_obs[i] := GetFloatValue('depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + ' observation point');
  t_unit := GetIntegerValue('unit of time');
  t_end  := GetFloatValue('final time');
  dt_ini := GetFloatValue('initial time increment');
  dt_max := GetFloatValue('maximum time increment');
  int_rec:= GetFloatValue('interval of report');
  rec    := GetIntegerValue('record profiles at the interval');
  if (Version > 1.01) and (Water) then
  begin
    IterationScheme := GetIntegerValue('handling of water capacity');
    InterHyCon      := GetIntegerValue('method for giving interblock conductivity');
    TargetMaxDiff_logP  := GetFloatValue('maximum permissible difference of pressure head in a time step');
    if Version < 1.23 then
      TargetMaxDiff_logP := 0.693;
    TargetESRErrorW := GetFloatValue('target relative error in water budget  at each time step');
    LowerTargetIteration := GetIntegerValue('lower boundary of target range for Celia' + #39 + 's iteration');
    UpperTargetIteration := GetIntegerValue('upper boundary of target range for Celia' + #39 + 's iteration');
    CriteriaForCeliasIteration := GetFloatValue('criteria for Celia' + #39 + 's iteration');
    if Pos('consider hysteresis', SL.Text) > 0 then
      ConsiderHysteresis := GetIntegerValue('consider hysteresis');
  end;
  if Version > 1.21 then
    Angle := GetIntegerValue('angle of soil surface');
  if (Water) or (Mode = 2) then
  begin
    for i := 1 to NumLayer do
      SoilName[i] := GetString(IntToStr(i) + PositionInfo.Suffix(i) + ' layer');
    //--- Water flow ---//
    ic_type := GetIntegerValue('type of initial condition for water');
    u_bc_type := GetIntegerValue('type of upper boundary condition for water');
    l_bc_type := GetIntegerValue('type of lower boundary condition for water');
    if (Version < 1.1) and (u_bc_type = 2) then
      u_bc_type := 3;
    Case ic_type of
    1: dumstr := 'initial volumetric water content = ';
    2: dumstr := 'initial pressure head(cm) = ';
    3: dumstr := 'initial pressure head(cm) at the top = ';
    end;
    if (Mode = 2) and (IPET_type = 1) and (UseOutflowforK = 0) then
      dumstr := 'initial pressure head(cm) at the top = ';
    if ic_type <= 3 then
    begin
      dum := GetFloatValue(dumstr);
      Case ic_type of
      1: W_ini := dum;
      2: P_ini := dum;
      3: P_top_ini := dum;
      end;
    end;
    if (IPET_type = 1) and (UseOutflowforK = 0) then
      P_top_ini := dum;
    p_bot     := GetFloatValue('pressure head(cm) at the bottom');
    HC_filter := GetFloatValue('hydraulic conductance of the filter');
    if ic_type = 4 then
      fl_profile := ConvertToFullPathName(GetString('file name for initial VWC profile'));
    case u_bc_type of
    1   : ql_top    := GetFloatValue('solution flux at the top');
    2   : Hpond     := GetFloatValue('pressure head(cm) at the top');
    3..4:
      begin
        if u_bc_type = 3 then
          fl_ql_top := ConvertToFullPathName(GetString('file name for solution flux at the soil surface'));
        if Version > 1.971 then
          ObsPtIrg := GetIntegerValue('observation point for automatic irrigation');
        if ObsPtIrg > 0 then
        begin
          ql_top        := GetFloatValue('solution flux at the top');
          AutoIrgDepth  := GetFloatValue('depth of automatic irrigation at each time');
          CriticalValue := GetFloatValue('critical value for automatic irrigation');
          if Version > 2.21 then
            Vreservoir_max := GetFloatValue('capacity of reservoir');
          if Vreservoir_max > 0 then
          begin
            Acatchment := GetFloatValue('area of catchment');
            Acropping  := GetFloatValue('area of cropping');
            StorageEfficiency := GetFloatValue('efficiency of storage');
            Vreservoir := GetFloatValue('initial storage');
            LossRate := GetFloatValue('loss rate');
          end;
        end;
        if Version > 2.481 then
          RefillInterval := GetIntegerValue('interval of refilling of available water in the root zone');
      end;
    end;
    if (l_bc_type = 4) or ((Mode = 2) and (IPET_Type = 2)) then
      fl_p_bot  := ConvertToFullPathName(GetString('file name for lower pressure head change'));
    case l_bc_type of
    4: fl_p_bot   := ConvertToFullPathName(GetString('file name for lower pressure head change'));
    5: fl_outflow := ConvertToFullPathName(GetString('file name for measured outflow data'));
    end;
    if Version > 1 then
      IniDrying := StrToBool(GetString('initially drying?'));
    abc_type  := GetIntegerValue('type of A.B.C.');
    ra        := GetFloatValue('aerodynamic resistance');
    if Mode = 2 then
      rm := 0
    else
      rm        := GetFloatValue('mulch resistance');
    Tair      := GetFloatValue('temperature of air');
    RHair     := GetFloatValue('relative humidity of air');
    if Version > 2.3 then
    begin
      ShortDateFormat := 'yy/mm/dd';
      DateSeparator := '/';
      S := GetString('start date');
      S := StringReplace(S, '-', DateSeparator, [rfReplaceAll]);
      StartDate := StrToDate(S);
      tin_a_day_ini := StrToFloat(GetString('start hour'));
      Latitude  := GetFloatValue('latitude');
    end;
    if (abc_type = 3) or ((IPET_type = 4) and (abc_type = 2)) then
      fl_clmtc_con   := ConvertToFullPathName(GetString('file name for measured evaporation rate'))
    else
      if abc_type >= 4 then
      begin
       fl_clmtc_con := ConvertToFullPathName(GetString('file name for climatic condition'));
       if Version > 1.95 then
         LoadingStartRow := GetIntegerValue('row number at which loading starts');
      end;
    if Version > 2.4 then
    begin
      Z_membrane:= GetFloatValue('depth of the membrane');
      if Z_membrane > 0 then
      begin
        HC_mb     := GetFloatValue('hydraulic conductance of the membrane');
        AEVmembrane:= GetFloatValue('air-entry value of the membrane');
        ExponentMembrane:=GetFloatValue('exponent of the membrane');
      end;
    end;
  end;
 //--- Solute Movement ---//
  if solute then
  begin
    CRWM        := 0;//GetIntegerValue('Convective Random Walk Model');
    MPP         := 0.001;//GetIntegerValue('mass simulated by a particle');
    s_ic_type   := GetIntegerValue('type of initial condition for solute');
    s_u_bc_type := GetIntegerValue('type of upper boundary condition for solute');
    s_l_bc_type := GetIntegerValue('type of lower boundary condition for solute');
    s_type      := GetIntegerValue('type of solute');
    S_crust     := GetIntegerValue('salty crust resistance');
    if Version > 1.341 then
      CDE_surface_modification := StrToBool(GetString('Apply surface modification for CDE?'));
    C_ini       := GetFloatValue('initial concentraion');
    C_irg       := GetFloatValue('concentration of irrigation water');
    C_bot       := GetFloatValue('concentration at the lower boundary');
    if Version > 1.342 then
      alpha_crys  := GetFloatValue('crystallization rate constant');
    if Version > 1.98 then
      kpu  := GetFloatValue('uptake ratio');
    if not water then
    begin
      Ds     := GetFloatValue('dispersion coefficient');
      q_irg := GetFloatValue('water flux');
    end;
    if s_ic_type > 1 then
      fl_iniCprofile := ConvertToFullPathName(GetString('file name for initial concentration profile'));
    if s_u_bc_type = 2 then
      fl_C_irg       := ConvertToFullPathName(GetString('file name for concentration of irrigation water'));
    if s_l_bc_type = 2 then
      fl_C_bot       := ConvertToFullPathName(GetString('file name for concentration at the lower boundary'));
  end;
  //--- Heat Movement ---//
  if heat then
  begin
    h_l_bc_type := GetIntegerValue('type of lower boundary condition for heat');
    Tbot := GetFloatValue('temperature at the lower boundary');
    Tini := GetFloatValue('initial temperature');
  end
  else
    Tini := Tair;
  //--- Inverse Paramater Estimation ---//
  if Mode = 2 then
  begin
    if (IPET_type <> 5) then
      Tensio    := GetIntegerValue('use of tensiometer');
    if IPET_type <= 2 then
      UseOutFlowForK := GetIntegerValue('use of outflow data for estimating hydraulic conductivity function');
    if IPET_type = 5 then
    begin
      UseFrontForK   := GetIntegerValue('use of infiltrating front for estimating hydraulic conductivity function');
      UseProfileForK := GetIntegerValue('use of final water content profile for estimating hydraulic conductivity function');
    end;
    if (IPET_type = 2) or (IPET_type = 3) or (IPET_type = 4) then
      AddRetData := GetIntegerValue('use of additional retention data');
    independent := GetIntegerValue('independet determination of the retention curve');
    W_end       := GetFloatValue('volumetric water content at the end');
    WsatFix     := GetIntegerValue('fixation of saturated volumetric water content');
    LlambdaFix    := GetIntegerValue('fixation of pressure head(cm) at oven dry');
    Linked_m    := GetIntegerValue('linkage of m to n');
    spFix       := GetIntegerValue('fixation of weighting factor in the bimodal retention function');
    ZetaFix     := GetIntegerValue('fixation of zeta in the retention function');
    WrFix       := GetIntegerValue('fixation of resident water content');
    KsatFix     := GetIntegerValue('fixation of saturated hydraulic conductivity');
    akFix       := GetIntegerValue('fixation of ak value in the hydraulic conductivity function');
    if IPET_type = 3 then
    begin
      t_slicing := GetFloatValue('Time when the slicing was performed');
      z_slice   := GetFloatValue('Thickness of the sliced layer');
      W_slice   := GetFloatValue('V.W.C. of the sliced layer');
    end;
    if Version > 1.215 then
      bkFix       := GetIntegerValue('fixation of bk value in the hydraulic conductivity function');
    if (IPET_type <= 3) or (IPET_type = 6) or (IPET_type = 7) or (IPET_type = 8) then
    begin
      fl_outflow := ConvertToFullPathName(GetString('file name for measured outflow data'));
    end;
    if (IPET_type = 1) or (W_end = 0) then
      fl_profile := ConvertToFullPathName(GetString('file name for measured water content profile'));
    if IPET_type = 1 then
    begin
      fl_clmtc_con := ConvertToFullPathName(GetString('file name for measured evaporation data'));
      if Version >= 1.0 then
      begin
        UseAdditionalHyConData := GetIntegerValue('use of additional hydraulic conductivity data');
        if UseAdditionalHyConData = 1 then
          fl_HyConData := ConvertToFullPathName(GetString('file name for additional hydraulic conductivity data'));
      end;
    end
    else
      if Tensio >= 1 then
        fl_pressure := ConvertToFullPathName(GetString('file name for pressure head measured by the tensiometer'));
    if (IPET_type = 1) or (AddRetData = 1) then
      fl_retention := ConvertToFullPathName(GetString('file name for additional retention data'));
    if IPET_Type = 5 then
    begin
      fl_outflow:= ConvertToFullPathName(GetString('file name for cumutlative infiltration'));
      if UseFrontForK = 1 then
        fl_front  := ConvertToFullPathName(GetString('file name for depth of infiltrating front'));
      if UseProfileForK = 1 then
        fl_profile:= ConvertToFullPathName(GetString('file name for measured water content profile'));
      Wfront := GetFloatValue('θ at the wetting front');
    end;
    if IPET_type = 11 then
      fl_c_profile:= ConvertToFullPathName(GetString('file name for concentration profile'));
    if (IPET_type = 4) and (Version > 2.1) then
      duration_ra :=  GetFloatValue('duration of ra determination');
  end;
  if (Mode = 3) or (RefillInterval > 0) then
    t_ql_top[1]:= GetFloatValue('irrigation start time');
  if Mode = 3 then
  begin
    WUE   := GetFloatValue('water use efficiency');
    Pcrop := GetFloatValue('price of crop');
    Pwater:= GetFloatValue('price of water');
    ql_top:= GetFloatValue('irrigation intensity');
    IDmax := GetFloatValue('maximum irrigation depth');
  end;
//------------------------------------//
  if (water) or (Mode = 2) then
    for i := 1 to NumLayer do
    begin
      SendDataToSoil;
      Soil.LoadProperties(i);
      RetrieveDataFromSoil;
    end;
  if abc_type >= 4 then
  begin
    PlantName := GetString('name of the plant');
    CumTr_ini := GetFloatValue('initial cumulative transpiration');
  end;
  if abc_type >= 4 then
    Plant.LoadProperties;
  GetVirtualFile;
  DialogBox := 1;
  GoAhead:=True;
  Caption := 'WASH_1D - ' + ExtractFileName(CaseName)
end;

function TMain.RoundToDecimalSF(Value : Double; SigFig : Integer) : Double;
var
  Places: ShortInt;
  N : Double;
begin
  if Value <> 0 then
  begin
    Places := SigFig - Ceil(log10(Abs(Value)));
    N := Power(10.0, Places);
    RoundToDecimalSF := (Round(Value * N) )/ N;
  end
  else
    RoundToDecimalSF := Value;
end;

function IntToBool(n: Integer): Boolean;
begin
  if n = 1 then
    Result := True
  else
    Result := False;
end;

procedure TMain.ManageWizard(Sender: TObject);
begin
  Execute1.Enabled := True;
  ToolButton4.Enabled := True;
  //------ DialogBox Management ----------//
  while DialogBox <> 0 do
    case DialogBox of
    1:begin
        GeneralInfo := TGeneralInfo.Create(Self);
        GeneralInfo.ShowModal;
        GeneralInfo.Release;
        if Mode = 1 then
          II.Visible := False
        else
          II.Visible := True;
        if Mode < 3 then
          IIRG.Visible := False
        else
          IIRG.Visible := True;
        Goahead := True;
        ISR.Enabled := Water;
        ISK.Enabled := Water;
        IW.Enabled  := Water;
        ISS.Enabled := Solute;
        ISM.Enabled := Solute;
        ISH.Enabled := Heat;
        ISE.Enabled := Heat;
        //IA.Enabled  := Heat;
        IPP.Enabled := (abc_type >= 4);
      end;
    2:begin
        PositionInfo := TPositionInfo.Create(Self);
        PositionInfo.seNumLayer.Value := NumLayer;
        PositionInfo.seNumObs.Value := NumObs;
        PositionInfo.ShowModal;
        PositionInfo.Release;
      end;
    3:begin
        if not Water then
          DialogBox := 5
        else
        begin
          SendDataToSoil;
          Soil.ShowModal;
          RetrieveDataFromSoil;
        end;
      end;
    4:begin
        if not Water then
          DialogBox := 1
        else
        begin
          Kparams := TKparams.Create(Self);
          SendDataToSoil;
          SendDataToKparams;
          Kparams.ShowModal;
          RetrieveDataFromSoil;
          RetrieveDataFromKparams;
          KParams.Release;
        end;
      end;
    5:begin
        if ((not Water) and (Mode = 1)) or (not solute) then
          if GoAhead = True then DialogBox := 6 else DialogBox := 4
        else
        begin
          STparams := TSTparams.Create(Self);
          STparams.ShowModal;
          STparams.Release;
        end;
      end;
    6:begin
        if not heat then
          DialogBox := 8
        else
        begin
          THCparams := TTHCparams.Create(Self);
          THCparams.ShowModal;
          THCparams.Release;
        end;
      end;
    7:begin
        if not heat then
          DialogBox := 5
        else
        begin
          EnFactor := TEnFactor.Create(Self);
          EnFactor.ShowModal;
          EnFactor.Release;
        end;
      end;
    8:begin
        if not Water then
          DialogBox := 10
        else
        begin
          WaterInfo := TWaterInfo.Create(Self);
          WaterInfo.ShowModal;
          WaterInfo.Release;
        end;
      end;
    9:begin
        if not Water then
          DialogBox  := 7
        else
          if (Mode <> 2) or (IPET_type <> 2) then
          begin
            AtmosBC := TAtmosBC.Create(Self);
            AtmosBC.ShowModal;
            AtmosBC.Release;
          end
          else
            DialogBox := 0;
      end;
   10:begin
        if Solute then
        begin
          SoluteInfo := TSoluteInfo.Create(Self);
          SoluteInfo.ShowModal;
          SoluteInfo.Release;
        end
        else
        begin
          if GoAhead = True then
            DialogBox := 11
          else
            DialogBox := 9;
        end;
      end;
   11:begin
        if Mode <> 2 then
        begin
          if GoAhead = True then
            DialogBox := 12
          else
            DialogBox := 10;
        end
        else
          if Water then
          begin
            InverseInfo := TInverseInfo.Create(Self);
            InverseInfo.ShowModal;
            InverseInfo.Release;
          end
          else
          begin
            SoluteInverseInfo := TSoluteInverseInfo.Create(Self);
            SoluteInverseInfo.ShowModal;
            SoluteInverseInfo.Release;
          end;
      end;
   12:begin
        if (Water) and (abc_type >= 4) then
        begin
          Plant.ShowModal;
        end
        else
          DialogBox := 0;
      end;
   13:begin
        Irrig.ShowModal;
      end
   else
      begin
        Language;
        Exit;
      end;
    end;
  FileSaveQuery;
  if AllowPerform = 1 then
    Perform(Sender);
end;
//----------------------------------------------------------
procedure TMain.Perform(Sender: TObject);
var
  i, button: Integer;
  x0, x1, x2, x3, y1, y2, accuracy, sign, ICF: Double;
  SL : TStringList;
  function f(x: Double): Double;
  begin
    t_ql_top[2] := t_ql_top[1] + x / ql_top;
    //t_ql_top[4] := 100000000000000000000000000;
    CumIrrigation[2] := x;
    CumIrrigation[3] := x;
    Simulator.Simulate;
    if CumTr_ini + CumTr < 20 then
      ICF := Min(10, (30 * (aKc + cKc) - aKc / bKc * (exp(bKc * 30) - 1) - dKc * Power(30 , eKc + 1) / (eKc + 1)) / (30 * Kc))
    else
      ICF := 1;
    Result := 100000 * sign * (Pcrop * WUE * CumTr * ICF - Pwater * x);
    SL.Add(FloatToStr(x) + Separator + FloatToStr(CumTr) + Separator + FloatToStr(Result));
  end;
begin
  //SendDataToKparams;
  if (Mode <> 2) or (IPET_type = 7) or (IPET_type = 8) then
  begin
    button:= Application.MessageBox('Would you like to watch graphs at each recording interval?', 'If you want fast termination, please click [NO]', 3); // yesnocancel
    case button of
      2: Exit; //cancel
      6: Graph := 1; //yes
      else
        Graph := 0;
    end;
    Wfc := Soil.Water_content_at_given_K(t_unit * 0.000001, 1);
  end;
  StatusBar1.Panels[0].Text := Msg[2];
  Case Mode of
    1:Simulator.Simulate;
    2:begin
        SendDataToSoil;
        ParamEstimator:= TParamEstimator.Create;//(Self);
        //ParamEstimator.Free;
      end;
    3:begin
       // t_ql_top[2] := t_ql_top[1];
      if RefillInterval = 0 then
        t_ql_top[3] := t_end + 1;
        {
        qltop[0]    := 0;
        qltop[1]    := 0;
        qltop[2]    := ql_top;
        qltop[3]    := ql_top;
        qltop[4]    := 0;
        qltop[5]    := 0;
        }
        //Num_qltop_Data := 3;
        SL := TStringList.Create;
        SL.Add('Irrig. (cm), Cum.Tr (cm), net income ($/ha)');
        try
          sign := 1;
         // if f(0.1) > f(0) then
          begin
            x0 := 0;
            x3 := IDmax;
            accuracy := IDmax / 10;
            AllowRecord := 0;
            f(x0);
            f(x3);
            x1 := x0 + (x3 - x0) * 0.382;
            x2 := x0 + (x3 - x0) * 0.618;
            y1 := f(x1);
            y2 := f(x2);
            repeat
              if y1 < y2 then
              begin
                x0 := x1;
                x1 := x2;
                y1 := y2;
                x2 := x0 + (x3 - x0) * 0.618;
                y2 := f(x2);
              end
              else
              begin
                x3 := x2;
                x2 := x1;
                y2 := y1;
                x1 := x0 + (x3 - x0) * 0.382;
                y1 := f(x1);
              end;
            until x3 - x0 < accuracy;
            AllowRecord := 1;
            f(0.5 * (x0 + x3));
          end;
          SL.SaveToFile(CaseName + '_Irg.txt');
        finally
          SL.Free;
        end;
        ShowMessage('Optimum irrigation depth = ' + FormatFloat('#0.00', (x1 + x2)/2) + 'cm. Expected net income is ' + FormatFloat('0.0', y1) + ' $/ha');
      end;
  end;
  ShowObservationFigure.Enabled := True;
  StatusBar1.Panels[0].Text := '  ' + comment;
  if rec = 1 then
    AnimatedFigure1Click(Sender);
end;
//----------------------------------------------------------
procedure TMain.PrintClick(Sender: TObject);
{$ifdef MSWINDOWS}
var
  ADevice, Adriver, Aport: array[0..255] of Char;
  DeviceHandle: Thandle;
  DevMode: PDeviceMode;
{$endif}
begin
  with Printer do
  try
    BeginDoc;
    Canvas.Font.Name := 'Courier New';
    Canvas.Font.Size := 10;
    Canvas.Font.Color := clBlack;
    {
    LineHeight := Round(1.2 * Abs(Canvas.TextHeight('I')));
    VerticalMargin := 4 * LineHeight;
    // There we go
    YPos := VerticalMargin;
    SuccessString := HEADLINE + DateTimeToStr(Now);
    }
    Canvas.TextOut(10, 10, 'Hello');
  finally
    EndDoc;
  end;


  {$ifdef MSWINDOWS}
  {
  if PrinterSetupDialog1.Execute then
  begin
    Printer.GetPrinter(ADevice, Adriver, Aport, DeviceHandle);
    DevMode := GlobalLock(DeviceHandle);
    with DevMode^ do
      begin
      dmFields := dmFields or DM_ORIENTATION;
      dmOrientation := DMORIENT_LANDSCAPE;
      end;
    if not DeviceHandle = 0 then GlobalUnLock(DeviceHandle);
    Print;
  end;
  }
{$endif}
end;
//--------  Call from Menu -> Input  ----------------------
procedure TMain.Wizard(n: Integer);
begin
  DialogBox := n;
  GoAhead := True;
  ManageWizard(Self);
end;

procedure TMain.IGClick(Sender: TObject);
begin
  Wizard(1);
end;
procedure TMain.IPClick(Sender: TObject);
begin
  Wizard(2);
end;
procedure TMain.ISRClick(Sender: TObject);
begin
  Wizard(3);
end;
procedure TMain.ISKClick(Sender: TObject);
begin
  Wizard(4);
end;
procedure TMain.ISSClick(Sender: TObject);
begin
  Wizard(5);
end;
procedure TMain.ISHClick(Sender: TObject);
begin
  Wizard(6);
end;
procedure TMain.ISEClick(Sender: TObject);
begin
  Wizard(7);
end;
procedure TMain.IWClick(Sender: TObject);
begin
  Wizard(8);
end;
procedure TMain.IAClick(Sender: TObject);
begin
  Wizard(9);
end;
procedure TMain.ISMClick(Sender: TObject);
begin
  Wizard(10);
end;
procedure TMain.IIClick(Sender: TObject);
begin
  Wizard(11);
end;
procedure TMain.IPPClick(Sender: TObject);
begin
  Wizard(12);
end;
procedure TMain.IIRGClick(Sender: TObject);
begin
  Wizard(13);
end;
//---------------------------------------------------------------------------
procedure TMain.Exit1Click(Sender: TObject);
begin
  Close;
end;
//----------------------------------------------------------
procedure TMain.TreatHistoryFile;
begin
  if rec <> 1 then Exit;
  dumstr := BaseDir + Slash + 'History' + Slash;
  dumstr := dumstr + ExtractFileName(CaseName) + '_001.txt';
  if FileExists(dumstr) = False then Exit;
  if Application.MessageBox(PChar(Msg[3]), PChar(Msg[4]),
     4) = 7 then
    DeleteHistoryFile
  else
  {$ifdef Linux}
    with ZipMaster do
    begin
      FSpecArgs.Clear;
      ZipFileName := CaseName + '_history.zip';
      dumstr := BaseDir + Slash + 'History' + Slash;
      if DirectoryExists(dumstr) = True then
        FSpecArgs.Add(dumstr);
      Add;
      Application.ProcessMessages;
      DeleteHistoryFile;
    end
  {$endif}
  ;
end;

procedure TMain.DeleteHistoryFile;
var i: Integer;
begin
  for i := 0 to Ceil(t_end / int_rec) do
  begin
    dumstr := BaseDir + Slash + 'History' + Slash;
    dumstr := dumstr + ExtractFileName(CaseName) + '_' + FormatFloat('000', i) + '.txt';
    if FileExists(dumstr) = True then
      DeleteFile(dumstr);
  end
end;

//------------------------------------------------------------------
procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(InifileName);
  try
    IniFile.WriteString('Options', 'CurrentFolder', GetRelativeDirectory(ExeDir, BaseDir));
    IniFile.WriteString('Options', 'DecimalSeparator', DecimalSeparator);
  finally
    IniFile.Free;
  end;
  ShowResult.Timer1.Enabled := False;
  TreatHistoryFile;
  Soil.Release;
  Plant.Release;
  ShowResult.Free;
  SL.Free;
  Simulator.Free;
  ShortDateFormat := 'yy/mm/dd';
  DateSeparator := '/';
  {$ifdef Linux}
  ZipMaster.Free;
  {$endif}
  Application.Terminate;
end;
//----------------------------------------------------------
procedure TMain.SaveInformations(Sender: TObject);
var
  i: Integer;
begin
  AllowPerform := 0;
  with SaveDialog1 do
  begin
    InitialDir := BaseDir;
    FileName := ExtractFileName(CaseName) + '.in';
    if Execute = True then
    begin
   //   ShowMessage(IntToStr(Pos('Demo', FileName)));
      {
      if (Pos('Demo', ExtractFileName(FileName)) <> 0) or (ExtractFileDir(FileName) = ExeDir + Slash + 'Examples') then
      begin
        ShowMessage(Msg[6]);
        Exit;
      end;
      }
      {
      if AnsiLowerCase(ExtractFileDir(FileName)) = AnsiLowerCase(ExeDir + Slash + 'Examples') then
      begin
        dumstr3 := 'You cannot save the case file into "\Examples". Please save it into another directory.';
        if Application.MessageBox(PChar(dumstr3), PChar(dumstr2), MB_OK) = IDOK
          then Exit;
      end;
      }
      if FileExists(FileName) then
        if Application.MessageBox(PChar(Msg[5]), PChar(''), 3) = 7 then
          Exit;
      AllowPerform := 1;
      FileName := ChangeFileExt(FileName, '.in');
      CaseName := Copy(FileName,1,Length(FileName)-3);
      BaseDir := ExtractFileDir(CaseName);
      Caption := 'WASH_1D - ' + ExtractFileName(CaseName);
      if rec0 = 1 then
        rec := 1;
      SaveInFile(True);
      if (Water) or (Mode = 2) then
        for i := 1 to NumLayer do
        begin
          SendDataToSoil;
          Soil.SaveProperties(i, True);
          RetrieveDataFromSoil;
        end;
        //  dumstr := FileName;
        //  Delete(dumstr, 1, Length(ExeDir));
      if abc_type >= 4 then
        Plant.SaveProperties(True);
      if RecentFileName[1] <> dumstr then
      begin
        RecentFile := TRecentFile.Create(Self);
        dumint := 11;
        dumstr := FileName;
        //Delete(dumstr, 1, Length(ExeDir));
        RecentFileName[12] := dumstr;
        //RecentFile.ListBox1.ItemIndex := 11;
        RecentFile.Close;
        RecentFile.Release;
      end
      else
        RecentFile.SaveRecentFile;
    end;
  end;
  GetVirtualFile;
end;

procedure TMain.SaveInFile(WriteOnFile: Boolean);
var i: Integer;
begin
  with SL do
  begin
    Clear;
    Add('>>>>>>>>>  Case Information File for WASH_1D version ' + FloatToStr(Version) + ' <<<<<<<<<<<');
    Add('');
    Add(comment);
    Add('');
    Add('============ General Information ======================');
    Add('Mode = ' + IntToStr(MODE));
    Add('water = ' + BoolToStr(water));
    Add('solute = ' + BoolToStr(solute));
    Add('heat = '+ BoolToStr(heat));
    Add('name of the plant = ' + PlantName);
    Add('--- Position Information ----');
    Add('depth of lower boundary = ' + FloatToStr(z_lb));
    Add('space increment at the top = ' + FloatToStr(z[1]));
    Add('space increment at the bottom = ' + FloatToStr(dz_bot));
    Add('number of layer = ' + IntToStr(NumLayer));
    if NumLayer >= 2 then
      for i := 1 to NumLayer - 1 do
        Add(' depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + 'border = ' + FloatToStr(z_border[i]));
    Add('number of observation point = ' + IntToStr(NumObs));
    for i := 1 to NumObs do
      Add(' depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + ' observation point = ' + FloatToStr(z_obs[i]));
    Add('--- time discretization ---- ');
    Add('unit of time = ' + IntToStr(t_unit));
    Add('final time = '+ FloatToStr(t_end));
    Add('initial time increment = ' + FloatToStr(dt_ini));
    Add('maximum time increment = ' + FloatToStr(dt_max));
    Add('interval of report = ' + FloatToStr(int_rec));
    Add('record profiles at the interval = ' + IntToStr(rec));
    if Water then
    begin
      Add('--- numerical detail ---- ');
      Add('handling of water capacity = ' + IntToStr(IterationScheme));
      Add('method for giving interblock conductivity = ' + IntToStr(InterHyCon));
      Add('maximum permissible difference of pressure head in a time step = ' + FloatToStr(TargetMaxDiff_logP));
      Add('target relative error in water budget  at each time step = ' + FloatToStr(TargetESRErrorW));
      Add('lower boundary of target range for Celia' + #39 + 's iteration = ' + IntToStr(LowerTargetIteration ));
      Add('upper boundary of target range for Celia' + #39 + 's iteration = ' + IntToStr(UpperTargetIteration ));
      Add('angle of soil surface = ' + IntToStr(Angle));
      Add('criteria for Celia' + #39 + 's iteration = ' + FloatToStr(CriteriaForCeliasIteration));
      Add('consider hysteresis = ' + IntToStr(ConsiderHysteresis));
    end;
    Add('--- name of the soil ---');
    for i := 1 to NumLayer do
      Add(IntToStr(i) + PositionInfo.Suffix(i) + ' layer = ' + SoilName[i]);
    //--- Water flow ---//
    Case ic_type of
    1: begin dumstr := 'initial volumetric water content = '; dum := W_ini; end;
    2: begin dumstr := 'initial pressure head(cm) = '; dum := P_ini; end;
    3: begin dumstr := 'initial pressure head(cm) at the top = '; dum := P_top_ini; end;
    4: begin dumstr := 'file name for water content profile = ' + GetRelativeDirectory(BaseDir, fl_profile); end;
    end;
    if (Mode = 2) and (IPET_type = 1) and (UseOutflowforK = 0) then
    begin
      dumstr := 'initial pressure head(cm) at the top = ';
      dum := P_top_ini;
    end;
    if (water) or (Mode = 2) then
    begin
      Add('');
      Add('=========== Water Flow Information ==========');
      Add('type of initial condition for water = ' + IntToStr(ic_type));
      Add('type of upper boundary condition for water = ' + IntToStr(u_bc_type));
      Add('type of lower boundary condition for water = ' + IntToStr(l_bc_type));
      if ic_type <= 3 then
        Add(dumstr + FloatToStr(dum))
      else
        Add(dumstr);
      case u_bc_type of
      1: Add('solution flux at the top = ' + FloatToStr(ql_top));
      2: Add('pressure head(cm) at the top = ' + FloatToStr(Hpond));
      3..4:
        begin
          Add('observation point for automatic irrigation = ' + IntToStr(ObsPtIrg));
          if ObsPtIrg > 0 then
          begin
            Add('depth of automatic irrigation at each time = ' + FloatToStr(AutoIrgDepth));
            Add('critical value for automatic irrigation = ' + FloatToStr(CriticalValue));
            Add('capacity of reservoir = ' + FloatToStr(Vreservoir_max));
            if Vreservoir_max > 0 then
            begin
              Add('area of catchment = ' + FloatToStr(Acatchment));
              Add('area of cropping = ' + FloatToStr(Acropping));
              Add('efficiency of storage = ' + FloatToStr(StorageEfficiency));
              Add('initial storage = ' + FloatToStr(Vreservoir));
              Add('loss rate = ' + FloatToStr(LossRate));
            end;
          end;
          Add('interval of refilling of available water in the root zone = ' + IntToStr(RefillInterval));
          Add('solution flux at the top = ' + FloatToStr(ql_top));
          if u_bc_type = 3 then
            Add('file name for solution flux at the soil surface = ' + GetRelativeDirectory(BaseDir, fl_ql_top));
        end;
      end;
      Add('pressure head(cm) at the bottom = ' + FloatToStr(p_bot));
      Add('hydraulic conductance of the filter = ' + FormatFloat('0.#######', HC_filter));
      Add('depth of the membrane = ' + FormatFloat('0.#######', Z_membrane));
      if Z_membrane > 0 then
      begin
        Add('hydraulic conductance of the membrane = ' + FormatFloat('0.#######', HC_mb));
        Add('air-entry value of the membrane = ' + FormatFloat('0.#######', AEVmembrane));
        Add('exponent of the membrane = ' + FormatFloat('0.#######', ExponentMembrane));
      end;
      if (fl_profile <> '') and (ic_type = 4) then
        Add('file name for initial VWC profile = ' + GetRelativeDirectory(BaseDir, fl_profile));
      case l_bc_type of
      4: Add('file name for lower pressure head change = ' + GetRelativeDirectory(BaseDir, fl_p_bot));
      5: Add('file name for measured outflow data = ' + GetRelativeDirectory(BaseDir, fl_outflow));
      end;
      Add('initially drying? = ' + BoolToStr(IniDrying));
      Add('>>-- Atmospheric Boundary Condition --<<');
      Add('type of A.B.C. = ' + IntToStr(abc_type));
      Add('aerodynamic resistance = ' + FormatFloat('#0.000', ra));
      Add('mulch resistance = ' + FormatFloat('#0.000', rm));
      Add('temperature of air = '+ FloatToStr(Tair));
      Add('relative humidity of air = ' + FloatToStr(RHair));
      Add('start date = ' + FormatDateTime('yy/mm/dd', StartDate)); // DateToStr(StartDate));
      Add('start hour = ' + FloatToStr(tin_a_day_ini));
      Add('latitude = ' + FloatToStr(latitude));
      if fl_clmtc_con <> '' then
        Add('file name for measured evaporation rate = ' + GetRelativeDirectory(BaseDir, fl_clmtc_con));
      if fl_clmtc_con <> '' then
      begin
        Add('file name for climatic condition = ' + GetRelativeDirectory(BaseDir, fl_clmtc_con));
        Add('row number at which loading starts = ' + IntToStr(LoadingStartRow));
      end;
      Add('initial cumulative transpiration = ' + FloatToStr(CumTr_ini));
    end;
    //--- Solute Movement ---//
    if solute then
    begin
      Add('');
      Add('============ Solute Movement ===========');
      Add('Convective Random Walk Model = ' + IntToStr(CRWM));
      Add('mass simulated by a particle = ' + FloatToStr(MPP));
      Add('type of initial condition for solute = ' + IntToStr(s_ic_type));
      Add('type of upper boundary condition for solute = ' + IntToStr(s_u_bc_type));
      Add('type of lower boundary condition for solute = ' + IntToStr(s_l_bc_type));
      Add('type of solute = ' + IntToStr(s_type));
      Add('salty crust resistance = ' + IntToStr(S_crust));
      Add('Apply surface modification for CDE? = ' + BoolToStr(CDE_surface_modification));
      Add('initial concentraion = ' + FloatToStr(C_ini));
      Add('concentration of irrigation water = ' + FloatToStr(C_irg));
      Add('concentration at the lower boundary = '+ FloatToStr(C_bot));
      Add('crystallization rate constant = '+ FloatToStr(alpha_crys));
      Add('uptake ratio = '+ FloatToStr(kpu));
      if not water then
      begin
        Add('dispersion coefficient =' + FloatToStr(Ds));
        Add('water flux = ' + FloatToStr(q_irg));
      end;
    if s_ic_type > 1 then
      Add('file name for initial concentration profile = ' + GetRelativeDirectory(BaseDir, fl_iniCprofile));
    if s_u_bc_type = 2 then
      Add('file name for concentration of irrigation water = ' + GetRelativeDirectory(BaseDir, fl_C_irg));
    if s_l_bc_type = 2 then
      Add('file name for concentration at the lower boundary = ' + GetRelativeDirectory(BaseDir, fl_C_bot));
    end;
    //--- Heat Movement ---//
    if heat then
    begin
      Add('');
      Add('============ Heat Movement ===========');
      Add('type of lower boundary condition for heat = ' + IntToStr(h_l_bc_type));
      Add('temperature at the lower boundary = '+ FloatToStr(Tbot));
    end;
    Add('initial temperature = ' + FloatToStr(Tini));
    //--- Inverse Parameter Estimation ---//
    if Mode = 2 then
    begin
      Add('');
      Add('============ Inverse Parameter Estimation ===========');
      Add('type of I.P.E. = '+ IntToStr(IPET_type));
      Add('use of tensiometer = ' + IntToStr(Tensio));
      if IPET_type <= 2 then
        Add('use of outflow data for estimating hydraulic conductivity function = ' + IntToStr(UseOutFlowForK));
      if (IPET_type = 2) or (IPET_type = 4) then
        Add('use of additional retention data = ' + IntToStr(AddRetData));
      if IPET_type = 3 then
      begin
        Add('Time when the slicing was performed = ' + FloatToStr(t_slicing));
        Add('Thickness of the sliced layer =' + FloatToStr(z_slice));
        Add('V.W.C. of the sliced layer = ' + FloatToStr(W_slice));
      end;
      if IPET_type = 11 then
        Add('file name for concentration profile = ' + GetRelativeDirectory(BaseDir, fl_c_profile));
      Add('independet determination of the retention curve = ' + IntToStr(independent));
      Add('volumetric water content at the end = ' + FloatToStr(W_end));
      Add('fixation of saturated volumetric water content = ' +  IntToStr(WsatFix));
      Add('fixation of pressure head(cm) at oven dry = ' + IntToStr(LlambdaFix));
      Add('linkage of m to n = ' + IntToStr(Linked_m));
      Add('fixation of weighting factor in the bimodal retention function = ' + IntToStr(spFix));
      Add('fixation of zeta in the retention function = ' + IntToStr(ZetaFix));
      Add('fixation of resident water content = ' + IntToStr(WrFix));
      Add('fixation of saturated hydraulic conductivity = ' + IntToStr(KsatFix));
      Add('fixation of ak value in the hydraulic conductivity function = ' + IntToStr(akFix));
      Add('fixation of bk value in the hydraulic conductivity function = ' + IntToStr(bkFix));
      if (IPET_type <= 3) or (IPET_type = 6) or (IPET_type = 7) or (IPET_type = 8) then
        Add('file name for measured outflow data = ' + GetRelativeDirectory(BaseDir, fl_outflow));
      if IPET_type = 1 then
      begin
        Add('file name for measured evaporation data = ' + GetRelativeDirectory(BaseDir, fl_clmtc_con));
        Add('use of additional hydraulic conductivity data = ' + IntToStr(UseAdditionalHyConData));
        if UseAdditionalHyConData = 1 then
          Add('file name for additional hydraulic conductivity data = ' + GetRelativeDirectory(BaseDir, fl_HyConData));
      end
      else
        if Tensio >= 1 then
        begin
          Add('file name for pressure head measured by the tensiometer = ' + GetRelativeDirectory(BaseDir, fl_pressure));
        end;
      if (IPET_type = 2) and (l_bc_type = 5) then
        Add('file name for lower pressure head change = ' + GetRelativeDirectory(BaseDir, fl_p_bot));
      if (IPET_type = 1) or (IPET_type = 4) or (IPET_type = 5) then
        Add('file name for measured water content profile = ' + GetRelativeDirectory(BaseDir, fl_profile));
      if fl_retention <> '' then
        Add('file name for additional retention data = ' + GetRelativeDirectory(BaseDir, fl_retention));
      if IPET_type = 5 then
      begin
        if fl_front = '' then
          UseFrontForK := 0
        else
          UseFrontForK := 1;
        if fl_profile = '' then
          UseProfileForK := 0
        else
          UseProfileForK := 1;
        Add('use of infiltrating front for estimating hydraulic conductivity function = ' + IntToStr(UseFrontForK));
        Add('use of final water content profile for estimating hydraulic conductivity function = ' + IntToStr(UseProfileForK));
        Add('file name for cumutlative infiltration = ' + GetRelativeDirectory(BaseDir, fl_outflow));
        Add('file name for depth of infiltrating front = ' + GetRelativeDirectory(BaseDir, fl_front));
        Add('θ of the wetting front = ' + FloatToStr(Wfront));
      end;
      if IPET_type = 4 then
        Add('duration of ra determination = ' + FloatToStr(duration_ra));
    end;
    if Mode = 3 then
    begin
      Add('');
      Add('============ Optimization of Irrigation Amount ===========');
      Add('water use efficiency = ' + FloatToStr(WUE));
      Add('price of crop = ' + FloatToStr(Pcrop));
      Add('price of water = ' + FloatToStr(Pwater));
      Add('irrigation start time = ' + FloatToStr(t_ql_top[1]));
      Add('irrigation intensity = ' + FloatToStr(ql_top));
      Add('maximum irrigation depth = ' + FloatToStr(IDmax));
    end;
    if WriteOnFile then
      SaveToFile(SaveDialog1.FileName)
    else
      VirtualFile := Text;
  //  Clipboard.AsText := Text;
  end;
end;

function TMain.CheckModified: Boolean;
var
  OldVirtualFile: String;
  {$ifdef debugging}
  i: Integer;
  {$endif}
begin
  OldVirtualFile := VirtualFile;
  GetVirtualFile;
  {$ifdef debugging}
  for i := 1 to Length(OldVirtualFile) - 1 do
  begin
    if OldVirtualFile[i] <> VirtualFile[i] then
      ShowMessage('Old:' + #13#10 +  Copy(OldVirtualFile, i, 70) + #13#10  + #13#10 + 'New:' + #13#10 + Copy(VirtualFile, i, 70));
  end;
  {$endif}
  if OldVirtualFile = VirtualFile then
    Result := False
  else
    Result := True;
end;

procedure TMain.GetVirtualFile;
var i: Integer;
begin
  SaveInFile(False);
  for i := 1 to NumLayer do
  begin
    SendDataToSoil;
    Soil.SaveProperties(i, False);
    VirtualFile := VirtualFile + Soil.VirtualFile;
    RetrieveDataFromSoil;
  end;
  Plant.SaveProperties(False);
  VirtualFile := VirtualFile + Plant.VirtualFile;
end;

function TMain.BoolToStr(V: Boolean): String;
begin
  if V = True then
    Result := 'True'
  else
    Result := 'False';
end;

function TMain.StrToBool(S: String): Boolean;
begin
  if S = 'True' then
    Result := True
  else
    Result := False;
end;
//----------------------------------------------------------
procedure TMain.About1Click(Sender: TObject);
begin
  GreetingBox:= TGreetingBox.Create(Self);
  with GreetingBox do
  begin
    ShowModal;
    Free;
  end;
end;
//----------------------------------------------------------
procedure TMain.ConvertToRateClick(Sender: TObject);
begin
  JustLoading := 0;
  ShowResult.ConvertToRate;
end;
////////////////////////////  Graphic Module  //////////////////////////////////
procedure TMain.Profile;
var
  Gheight, Gwidth, Glmargin, Gtmargin, i, step: Integer;
//  GXmax, GXmin, GYmax, GYmin : Single;
begin
  Gheight  := Trunc(5*45*Vadjuster);
  Gwidth   := Trunc(6*50*Hadjuster);
  Glmargin := Trunc(50*Hadjuster);
  Gtmargin := Height - Gheight - 150;
  HyperText.TargetCanvas := Image1.Canvas;
  with Image1.Canvas do
  begin
    Brush.Color := clWhite;
    Brush.Style:= bsSolid;
    Rectangle(-1, -1, Image1.Width+1, Image1.Height+1);
    Pen.Color := clBlack;
    Image1.Canvas.Font.Size := Trunc(StdFontSize * Vadjuster);
    Rectangle (Glmargin, Gtmargin, Glmargin + Gwidth, Gtmargin + Gheight);
    //----  U axis ----//
    for i := 0 to 5 do
    begin
      Moveto(Glmargin + Gwidth div 6 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 6 * i, Gtmargin + 8);
    end;
    Font.Color := clBlue;
    SetDefaultFont;
    for i := 0 to 6 do
      TextOut(Glmargin + Gwidth div 6 * i - Trunc(4 * Hadjuster) , Gtmargin - Trunc(20*Vadjuster), FloatToStr(0.1*i));
    TextOut(Glmargin + Trunc(80*Hadjuster) , Gtmargin- Trunc(38*Vadjuster) , Msg[7]);
    //----  X axis ----//
    Pen.Color := clSilver;
    Pen.Style := psDot;
    for i := 1 to 5 do
    begin
      Moveto(Glmargin + Gwidth div 6 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 6 * i, Gtmargin + Gheight);
    end;
    if solute then
    begin
      Font.Color := $009090;
      step := Max(15 * Ceil(Max(c_ini, C_irg) / 6), 6) div 6;
      for i := 0 to 6 do
        TextOut(Glmargin + Gwidth div 6 * i - 3 , Gtmargin  + Gheight + 1, FloatToStr(i*step));
      HyperText.Write(Msg[8], Glmargin + Trunc(70*Hadjuster) , Gtmargin + Gheight + Trunc(20*Vadjuster), 0);
      SetDefaultFont;
    //  TextOut(Glmargin + Trunc(75*adjuster) , Gtmargin + Gheight + Trunc(20*adjuster) , dumstr);
    end;
    if heat then
    begin
      Font.Color := $000080FF;
      for i := 1 to 5 do
        TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight - Trunc(22*Vadjuster) , FloatToStr(-10+10*i));
      TextOut(Glmargin+ Trunc(100*Hadjuster) , Gtmargin + Gheight - Trunc(40*Vadjuster) , Msg[9]);
    end
    else
    begin
      Font.Color := clGray;
      if solute then
      begin
        for i := 1 to 5 do
          TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight - Trunc(18*Vadjuster) , FloatToStr(-200 + 40 * i));
        dumint := - Trunc(32*Vadjuster);
      end
      else
      begin
        for i := 0 to 6 do
          if P[n] > -150 then
            TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight + 2 , FloatToStr(-150 +  25 * i))
          else
            TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight + 2 , FloatToStr(-900 + 150 * i));
        dumint := Trunc(20*Vadjuster);
      end;
      TextOut(Glmargin+ Trunc(95*Hadjuster) , Gtmargin + Gheight + dumint , Msg[10]);
    end;
    //----- Y axis ----//
    Font.Color := clBlack;
    for i := 1 to 4 do
    begin
      Moveto(Glmargin          , Gtmargin + Gheight - Gheight * i div 5);
      Lineto(Glmargin + Gwidth , Gtmargin + Gheight - Gheight * i div 5);
    end;
    if z_lb < 25 then dumint := 10 else dumint := 25;
    dumint := (Ceil(z_lb / dumint) * dumint) div 5;
    for i := 0 to 5 do
      TextOut(Glmargin - Trunc(20*Hadjuster) , Gtmargin + Gheight * i div 5 - 5, FloatToStr(i*dumint));
    TextOut(Trunc(2*Hadjuster), Gtmargin + Trunc(80*Vadjuster) , Msg[11]);
    TextOut(0, Gtmargin + Trunc(100*Vadjuster) , '(cm)');
    Pen.Style := psSolid;
    if (Mode = 2) and (IPET_type = 1) then
    begin
      Pen.Color := clOlive;
      Moveto (Glmargin + 50 - 20, Gtmargin + Gheight * 3 div 4 - 11);
      Lineto (Glmargin + 50 +  5, Gtmargin + Gheight * 3 div 4 - 11);
      Font.Size := Trunc(StdFontSize * Vadjuster);
      TextOut(Glmargin + 50 + 10, Gtmargin + Gheight * 3 div 4 - 16, 'Measured water content');
    end;
    Pen.Color := cl3DLight;
    Moveto(Image1.Width - 1, 0);
    Lineto(Image1.Width - 1, Image1.Height - 1);
    Lineto(0, Image1.Height - 1);
  end;
  //sleep(1000);
end;
//----------------------------------------------------------
procedure TMain.DrawProfile(GX, GY : Array of Double; NumPoint: Integer; GXmin, GXmax :Double; Lcol: Integer);
var
  Gheight, Gwidth, Glmargin, Gtmargin,i: Integer;
  GYmax, GYmin : Single;
begin
  Gheight  := Trunc(5*45*Vadjuster);
  Gwidth   := Trunc(6*50*Hadjuster);
  Glmargin := Trunc(50*Hadjuster);
  Gtmargin := Height - Gheight - 150;
  if z_lb < 25 then
    dumint := 10
  else
    dumint := 25;
  GYmax := Ceil(z_lb / dumint) * dumint;
  GYmin := 0;
  with Image1.Canvas do
  begin
    Pen.Color := Lcol;
   // GX[NumPoint] := Max(GX[NumPoint], GXmin);
    dum := GX[NumPoint];
    Moveto(Glmargin + Trunc((GX[NumPoint] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[NumPoint] - GYmin)/(GYmax - GYmin) * Gheight));
    for i := NumPoint - 1 downto 1 do
    begin
      //if GX[i] < GXmin then
      //  Moveto(Glmargin, Gtmargin + Trunc((GY[i] - GYmin)/(GYmax - GYmin) * Gheight))
      //else
        Lineto(Glmargin + Max(-100, Trunc((GX[i] - GXmin)/(GXmax - GXmin) * Gwidth)), Gtmargin + Trunc((GY[i] - GYmin)/(GYmax - GYmin) * Gheight));
    end;
  end;
end;
//----------------------------------------------------------
procedure TMain.FluxProfile;
var
  Gheight, Gwidth, Glmargin, Gtmargin, i: Integer;
  GXmax, GXmin: Single;
begin
  Gheight  := Trunc(5*45*Vadjuster);
  Gwidth   := Trunc(8*50*Hadjuster);
  Glmargin := Trunc(450*Hadjuster);
  Gtmargin := Height - Gheight - 150;
  if abc_type = 1 then
  begin
    GXmax := 0;
    GXmin := -100;
  end
  else
  begin
    GXmax := 40;
    GXmin := -60;
  end;
  with Image1.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clWhite;
    Rectangle(Glmargin-1, Gtmargin-1, Glmargin+Gwidth+1, Gtmargin+Gheight+1);
    //----  X axis ----//
    Pen.Color := clBlack;
    Pen.Style := psSolid;
    Moveto(Glmargin         , Gtmargin);
    Lineto(Glmargin + Gwidth, Gtmargin);
    Pen.Style := psDot;
    Pen.Color := clSilver;
    for i := 0 to 10 do
    begin
      Moveto(Glmargin + Gwidth div 10 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 10 * i, Gtmargin + Gheight);
    end;
    SetDefaultFont;
    for i := 0 to 10 do
      TextOut(Glmargin + Gwidth div 10 * i - Trunc(14 *Hadjuster) , Gtmargin - Trunc(20*Vadjuster), Simulator.SetLengthRJ(FormatFloat('##0', GXmin + i * (GXmax - GXmin)/10), 4));
    TextOut(Glmargin+ Trunc(120*Hadjuster) , Gtmargin- Trunc(40*Vadjuster) , Msg[12]);
    //----- Y axis ----//
    for i := 0 to 4 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight - Gheight * i div 5);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Gheight * i div 5);
    end;
    Pen.Style := psSolid;
   {
    for i := 0 to 6 do
      TextOut(Glmargin - Trunc(20*adjuster) , Gtmargin + Gheight * i div 6 - 5, FloatToStr(i*10));
    TextOut(Trunc(8*adjuster) ,Trunc(190*adjuster) , 'z');
    TextOut(0,Trunc(205*adjuster) , '(cm)');
   }
    Font.Color := clBlack;
    SetDefaultFont;
    if abc_type <> 1 then
    begin
      Pen.Color := clAqua;
      Moveto (Glmargin + Gwidth * 4 div 5 - 30, Gtmargin + Gheight * 2 div 3);
      Lineto (Glmargin + Gwidth * 4 div 5     , Gtmargin + Gheight * 2 div 3);
      TextOut(Glmargin + Gwidth * 4 div 5 +  5, Gtmargin + Gheight * 2 div 3 - 4, Msg[13]);
      Pen.Color:= clNavy;
      Moveto (Glmargin + Gwidth * 4 div 5 - 30, Gtmargin + Gheight * 2 div 3 + 21);
      Lineto (Glmargin + Gwidth * 4 div 5     , Gtmargin + Gheight * 2 div 3 + 21);
      TextOut(Glmargin + Gwidth * 4 div 5 +  5, Gtmargin + Gheight * 2 div 3 + 17, Msg[14]);
      TextOut(Glmargin + 10, Gtmargin+Gheight - 65, Msg[15]);
      TextOut(Glmargin + 140, Gtmargin+Gheight - 65, '= '+ FormatFloat('##0.0',Evap[counter]) + 'mm/d     ');
    end;
    TextOut(Glmargin + 10                     , Gtmargin + Gheight - 45, Msg[16]);
    TextOut(Glmargin + 20 + TextWidth(Msg[17]), Gtmargin + Gheight - 45, '= '+ FormatFloat('##0.0', ql[1]) + 'mm/d     ');
    TextOut(Glmargin + 10                     , Gtmargin + Gheight - 25, Msg[17]);
    TextOut(Glmargin + 20 + TextWidth(Msg[17]), Gtmargin + Gheight - 25, '= '+ FormatFloat('##0.0', ql[n]) + 'mm/d     ');
  end;
end;
//----------------------------------------------------------
procedure TMain.DrawFluxProfile(var GX, GY : Array of Double; Lcol: Integer);
var
  Gheight, Gwidth, Glmargin, Gtmargin,i: Integer;
  GXmax, GXmin, GYmax, GYmin: Single;
begin
  Gheight  := Trunc(5*45*Vadjuster);
  Gwidth   := Trunc(8*50*Hadjuster);
  Glmargin := Trunc(450*Hadjuster);
  Gtmargin := Height - Gheight - 150;
  if abc_type = 1 then
    begin
    GXmax:= 0; GXmin:= -100
    end
  else
    begin
    GXmax:= 40; GXmin:= -60;
    end;
  if z_lb < 25 then dumint:= 10 else dumint:= 25;
  GYmax:= Ceil(z_lb / dumint) * dumint;
  GYmin:= 0;
  with Image1.Canvas do
  begin
    Pen.Color:= Lcol;
    Moveto(Glmargin + Trunc((GX[1]   - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[1]   - GYmin)/(GYmax - GYmin) * Gheight));
    for i :=1 to n-1 do
      Lineto(Glmargin + Trunc((GX[i+1] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[i+1] - GYmin)/(GYmax - GYmin) * Gheight));
    Pen.Color:= clBlack;
    Moveto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin);
    Lineto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin + Gheight);
  end;
end;
//----------------------------------------------------------
procedure TMain.History;
var
  Gheight, Gwidth, Glmargin, Gtmargin, i, j: Integer;
  nday : Integer;
  GXmax: Integer;
  GXmin, GYmax, GYmin, GYmax_, GYmin_: Single;
begin
  Gheight := Trunc(10*20*Vadjuster);
  Gwidth  := Trunc(480*Hadjuster);
  Glmargin:= Trunc(470*Hadjuster);
  Gtmargin:= Trunc(15*Vadjuster);
  nday:=Ceil(time_ * t_unit/86400 - 0.01);
  if nday = 0 then
    nday:= 1;
  GXmax:= nday; //2 * (((nday - 1) div 2) + 1);
  if IPET_type < 7 then
    GXmin:= Max(nday - 9, 0)
  else
    GXmin:= 0;
  GYmax:= 40;
  GYmin:=-60;
  HyperText.TargetCanvas:= Image1.Canvas;
 // HyperText.MagScreen:= 0.1;//1 / HyperText.Adjuster;
  with Image1.Canvas do
  begin
    Brush.Color:= clWhite;
    Brush.Style:= bsSolid;
    Pen.Color:= clWhite;
    Rectangle(Glmargin-1, Gtmargin-1, Glmargin+Gwidth+1, Gtmargin+Gheight+1);
    Brush.Style:= bsClear;
    Font.Size:= Trunc(0.92 * StdFontSize * Vadjuster) ;
    Font.Color:= clBlack;
    //----  X axis ----//
    Pen.Style:= psDot;
    Pen.Color:= clSilver;
    if IPET_type < 7 then
      j := Min(nday, 10)
    else
      j := nday;
    if nday > 1 then
    begin
      for i := 0 to j do
      begin
        Moveto(Glmargin + Gwidth div j * i, Gtmargin); //+ Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) - 4
        Lineto(Glmargin + Gwidth div j * i, Gtmargin + Gheight);
      end;
      Font.Color:= clBlack;
      for i := Trunc(GXmin) to nday do
        TextOut(Glmargin + Gwidth div j * (i - Trunc(GXmin)) - 5,
                Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + 1,
                Simulator.SetLengthRJ(IntToStr(Max(i, GXmax div nday * i)), 3));
      TextOut(Glmargin+ Trunc(220*Hadjuster) , Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + Trunc(12*Vadjuster), Msg[18]);
    end
    else
    begin
      for i := 0 to 6 do
      begin
        Moveto(Glmargin + Gwidth div 6 * i, Gtmargin);
        Lineto(Glmargin + Gwidth div 6 * i, Gtmargin + Gheight);
      end;
      Font.Color:= clBlack;
      for i := 0 to 6 do
        TextOut(Glmargin + Gwidth div 6 * i + 1,
                Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + 1,
                Simulator.SetLengthRJ(IntToStr(24 div 6 * i), 2));
    end;
    //----- Y axis ----//
    for i := 0 to 10 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight * i div 10);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight * i div 10);
    end;
   // TextOut(Glmargin+ Trunc(220*adjuster) , Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + Trunc(12*adjuster), Msg[19]);
    Pen.Style:= psSolid;
    Pen.Color:= clBlack;
    Moveto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin);
    Lineto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin + Gheight);
    Pen.Color:= clBlue;
    //
    Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 1 div 5 + 8);
    Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 1 div 5 + 8);
    Font.Color:=clBlue;
    Font.Size:= Trunc(0.9 * StdFontSize * Vadjuster); // 1.1 *
    dumstr:= ' [r]θ at [i]z[ ][a] = ' +  FormatFloat('#0.0', z_obs[1]) + 'cm';
    HyperText.Write(dumstr, Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 1 div 5, 0);
    // cumulative outflow and evaporation //
    if Mode = 2 then
    begin
      Font.Color:=clNavy;
      Font.Size:= Trunc(0.9 * StdFontSize * Vadjuster);
      //Font.Size:= Trunc(8*adjuster);
      case IPET_type of
      5:begin
          GYmax_:=   8;
          GYmin_:= -12;
          j:= 17;
        end;
      6:begin
          GYmax_:= GYmax * 5;
          GYmin_:= GYmin * 5;
          j:= 22;
        end;
      else
        begin
          GYmax_:= GYmax / 20;
          GYmin_:= GYmin / 20;
          j:= 17;
        end;
      end;
      for i := 0 to 4 do
        TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(j * Hadjuster),
                Gtmargin + Gheight * i div 10 - 3,
                Simulator.SetLengthRJ(FormatFloat('#0.0', GYmax_ - (GYmax_ - GYmin_) / 10 * i), 3));
      //
      Pen.Color:= clOlive;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 - 14);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 - 14);
      Font.Color:=clOlive;
      Font.Size:= Trunc(0.9 * StdFontSize * Vadjuster);
      if (IPET_type = 1) or (IPET_type = 4) then
        dumstr:= ' or [r]Σ[i]E*'
      else
        if Tensio >= 1 then
          dumstr:= ' or [r]ψ* at [i]z[ ][a] = ' + FormatFloat('#0.0', z_obs[1]) + 'cm'
        else
          dumstr:= '';
      if IPET_type <> 4 then
        HyperText.Write('[i]Σ[r][~]q[.][_]bot[-]*[ ]' + dumstr ,Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 - 22, 0);
      //
      Pen.Color:= clNavy;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 1 div 5 + 22);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 1 div 5 + 22);
      Font.Color:=clNavy;
      HyperText.Write('[r]Σ[i][~]q[.][_]bot[-]', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 1 div 5 + 14, 0);
    end
    else
    // water flux //
    begin
      Font.Color:= clNavy;
      Pen.Color:= clNavy;
      if Mode <> 2 then dum:= 1 else dum:= 10;
      Font.Size:= Trunc(0.9 * StdFontSize * Vadjuster);
      for i := 0 to 10 do
        TextOut(Glmargin - Trunc(20*Hadjuster),
                Gtmargin + Gheight * i div 10 - 4,
                Simulator.SetLengthRJ(FormatFloat('##0', GYmax - (GYmax - GYmin)/ 10 * i),3));
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 + 28);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 + 28);
      Font.Size:= Trunc(0.9 * StdFontSize * Vadjuster);
      HyperText.Write(' - [r][i]q[_][.] l bot[ ][-][a] (mm/d)', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 + 20, 0);
    end;
    if (IPET_type <> 2) then
    begin
      Pen.Color:= clAqua;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 + 14);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 + 14);
      HyperText.Write('[r][i]E[ ]',Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 + 6, 0);
    end
    else
    begin
      Font.Color:= clTeal;  Pen.Color:= clTeal;  Pen.Style:= psDot;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 + 14);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 + 14);
      HyperText.Write('[ ][r]ψ[i][_] bot[ ]', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 + 6, 0);
    end;
    Font.Size:= Trunc(0.9 * StdFontSize * Vadjuster);
    dumint:= 20;
    // temperature //
    if heat then
    begin
      Font.Color:= $000080FF;
      dumint:= dumint + 13;
      for i := 0 to 4 do
        TextOut(Glmargin - Trunc(dumint*Hadjuster),
                Gtmargin + (Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin))) * i div 4 - 4,
                Simulator.SetLengthRJ(FloatToStr(10*(4-i)),2));
    end;
    // water content //
    Font.Color:= clBlue;
    dumint:= dumint + 16;
    Font.Style:= [];
    for i := 0 to 4 do
       TextOut(Glmargin - Trunc(dumint*Hadjuster),
               Gtmargin + (Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin))) * i div 4 - 4,
               Simulator.SetLengthRJ(FloatToStr(0.1*(4-i)),3));
    // concentration //
    dumint:= dumint + 16;
    if solute then
    begin
      Font.Color:= $009090;
      for i := 0 to 4 do
        TextOut(Glmargin - Trunc(dumint*Hadjuster),
                Gtmargin + (Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin))) * i div 4 - 4,
                FloatToStr(2*(4-i)));
    end;
    // pressure head //
    if Mode = 2 then dumint:= 30 else dumint:= 50;
    Font.Color:= clTeal;
    // Gwidth * (0 - GXmin)/(GXmax - GXmin))
    for i := 0 to 5 do
      TextOut(Glmargin - Trunc(dumint*Hadjuster),
              Gtmargin + Gheight - Gheight div 10 * i - 4,
              Simulator.SetLengthRJ(FloatToStr(-100*(6-i)),4));
    Pen.Color:= clTeal;  Pen.Style:= psSolid;
    Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5);
    Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5);
    Font.Size:= Trunc(1.1 * StdFontSize * Vadjuster);
    HyperText.Write('[r]ψ at [i]z[ ][a] = ' + FormatFloat('#0.0', z_obs[1]) + 'cm', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 - 8, 0);
    Pen.Color:= cl3DLight;
  end;
end;
//----------------------------------------------------------
procedure TMain.HistoryDraw(GX, GY : Array of Double; StartPoint, EndPoint: Integer; GYmin, GYmax: Double; Lcol: Integer; PenStyle: TPenStyle);
var
  Gheight, Gwidth, Glmargin, Gtmargin, i: Integer;
  nday : Integer;
  GXmax, GXmin: Single;
begin
  Gheight := Trunc(10*20*Vadjuster);
  Gwidth  := Trunc(480*Hadjuster);
  Glmargin:= Trunc(470*Hadjuster);
  Gtmargin:= Trunc(15*Vadjuster);
  nday:= Ceil(time_ * t_unit/86400 - 0.01);
  if nday = 0 then
    nday:= 1;
  GXmax:= (86400 div t_unit) * nday; // (86400/ t_unit) * 2 * (((nday - 1) div 2) +1);
  if (Mode = 1) or (RefillInterval > 0) then
    GXmin:= GX[StartPoint]
  else
    GXmin:= 0;
  with Image1.Canvas do
  begin
    Pen.Color:= Lcol;
    Pen.Style:= PenStyle;
     Moveto(Glmargin + Trunc((GX[StartPoint] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[StartPoint] - GYmin)/(GYmax - GYmin) * Gheight));
    for i := StartPoint to EndPoint-1 do
      if (Abs(GY[i+1]) < Abs(GYmin)*10) and (Abs(GY[i+1]) < Abs(GYmax)*10) then
        Lineto(Glmargin + Trunc((GX[i+1] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i+1] - GYmin)/(GYmax - GYmin) * Gheight))
      else
        Moveto(Glmargin + Trunc((GX[i+1] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i+1] - GYmin)/(GYmax - GYmin) * Gheight));
    Pen.Color:= clBlack;
    Pen.Style:= psSolid;
    Moveto(Glmargin         , Gtmargin + Gheight * 4 div 10);
    Lineto(Glmargin + Gwidth, Gtmargin + Gheight * 4 div 10);
      //Moveto(Glmargin,          Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)));
      //Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)));
  end;
end;
//----------------------------------------------------------
procedure TMain.DrawProperty;
var
  Gheight, Gwidth, Glmargin, Gtmargin, i : Integer;
  GXmax, GXmin, GYmax, GYmin : Single;
  GX, GY: array[0..50] of Double;
begin
  Gheight := Trunc(5*45*Vadjuster);
  Gwidth  := Trunc(7*47*Hadjuster);
  Glmargin:= Trunc(600*Hadjuster);
  Gtmargin:= Height - Gheight - 150;;
  GXmax:= 0.7; GXmin:=0;
  with Image1.Canvas do
  begin
    Brush.Color:= clWhite;
    Rectangle(Glmargin-1, Gtmargin-1, Glmargin+Gwidth+1, Gtmargin+Gheight+1);
    Pen.Style:= psSolid;
    Pen.Color:= clBlack;
    Font.Size:= Trunc(StdFontSize * Vadjuster) ;
    Rectangle(Glmargin-1, Gtmargin-1, Glmargin+Gwidth+1, Gtmargin+Gheight+1);
    //----  X axis ----//
    Pen.Style:= psDot;
    Pen.Color:= clSilver;
    for i := 1 to 6 do
    begin
      Moveto(Glmargin + Gwidth div 7 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 7 * i, Gtmargin + Gheight);
    end;
    for i := 0 to 7 do
      TextOut(Glmargin + Gwidth div 7 * i - 3 , Gtmargin  + Gheight + 2, FloatToStr(i/10));
    TextOut(Glmargin + Trunc(60*Hadjuster) , Gtmargin + Gheight + Trunc(20*Vadjuster) , Msg[7]);
    //----- Y axis ----//
    GYmax:= 7; GYmin:= 0;
    for i := 1 to 6 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight - Gheight * i div 7);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Gheight * i div 7);
    end;
    SetDefaultFont;
    for i := 0 to 7 do
      TextOut(Glmargin - Trunc(20*Hadjuster) , Gtmargin + Gheight * i div 7 - 5, IntToStr(7-i));
    TextOut(Glmargin - Trunc(50*Hadjuster) , Gtmargin + Trunc(100*Vadjuster) , 'pF');
    TextOut(0,Trunc(175*Vadjuster) , '');
   //----- R axis ----//
    for i := 1 to 5 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight - Gheight * i div 7);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Gheight * i div 7);
    end;
    for i := 0 to 6 do
      TextOut(Glmargin + Gwidth + Trunc(10*Hadjuster) , Gtmargin + Gheight * i div 7 - 5, IntToStr(-i*2));
    TextOut(Glmargin + Gwidth + 35 , Gtmargin + Trunc(130*Vadjuster) , 'log K');
    TextOut(Glmargin + Gwidth + 35 , Gtmargin + Trunc(150*Vadjuster) , '(cm/s)');
    //--- Retention Curve ---//
    Pen.Style:= psSolid;
    Pen.Color:= clBlack;
    with Soil do
      for i := 1 to 50 do
      begin
        GY[i]:= - Power(10, 7/50*i);
        GX[i]:= Soil.Water_Content(GY[i], Tref[1], Wsat[1], zeta[1], Wr[1], 1, Drying[1]);
      end;
    for i := 1 to 49 do
    begin
      if (IPET_type <> 3) and (IPET_type <> 5) and (GX[i+1] < W[1]) then
        Pen.Color:= clSilver
      else
        Pen.Color:= clBlack;
      if GX[i] > 0 then
      begin
        Moveto(Glmargin + Trunc((GX[i]  - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((log10(-GY[i])  - GYmin)/(GYmax - GYmin) * Gheight));
        Lineto(Glmargin + Trunc((GX[i+1]- GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((log10(-GY[i+1])- GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    //-- Retention Data --//
    Pen.Color:= clBlack;
    if Wretm[1] > 0 then
    begin
      if (Tensio >= 1) and (independent <> 1) then
        dumint:= 2
      else
        dumint:= 1;
      if IPET_type = 1 then
        dumint:= 0;
      for i := 1 to NumAddRetData + dumint do
      begin
        if Pretm[i] <> 0 then
          Rectangle(-3 + Glmargin + Trunc((Wretm[i] - GXmin)/(GXmax - GXmin) * Gwidth), -3 +Gtmargin + Gheight - Trunc((log10(-Pretm[i]) - GYmin)/(GYmax - GYmin) * Gheight),
                    +3 + Glmargin + Trunc((Wretm[i] - GXmin)/(GXmax - GXmin) * Gwidth), +3 +Gtmargin + Gheight - Trunc((log10(-Pretm[i]) - GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    //--- Hydraulic Conductivity Curve ---//
    GYmax:= 0; GYmin:= -14;
    with Soil do
      for i := 1 to 50 do
      begin
        if KF[1] <> 2 then
          GX[i]:= (Wsat[1] - Wr[1]) * i / 50 + Wr[1]
        else
          if bk[1] < 0 then
            GX[i]:= (Wsat[1] + bk[1] * Wsat[1]) * i / 50 - bk[1] * Wsat[1]
          else
            GX[i]:= Wsat[1] * i / 50;
        dum:= HydraulicConductivity(GX[i] * 0.9999, Tref[1], 1) / t_unit;
        if dum > 0 then
          GY[i]:= log10(dum)
        else
          GY[i]:= -30;
      end;
    for i := 49 downto 1 do
    begin
      if GY[i] < -14 then break;
      if (IPET_type <> 3) and (IPET_type <> 5) and (GX[i+1] < W[1]) then
        Pen.Color:= clSilver
      else
        Pen.Color:= clBlack;
      Moveto(Glmargin + Trunc((GX[i]  - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i]  - GYmin)/(GYmax - GYmin) * Gheight));
      Lineto(Glmargin + Trunc((GX[i+1]- GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i+1]- GYmin)/(GYmax - GYmin) * Gheight));
    end;
    //-- Hydraulic Conductivity Data --//
    Pen.Color:= clBlue;
    if IPET_type = 4 then
    begin
      for i := 1 to NumDirectKdata do
      begin
        Rectangle(-3 + Glmargin + Trunc((W_direct[i] - GXmin)/(GXmax - GXmin) * Gwidth), -3 + Gtmargin + Gheight - Trunc((log10(K_direct[i]) - GYmin)/(GYmax - GYmin) * Gheight),
                  +3 + Glmargin + Trunc((W_direct[i] - GXmin)/(GXmax - GXmin) * Gwidth), +3 + Gtmargin + Gheight - Trunc((log10(K_direct[i]) - GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    if Wkm[1] > 0 then
    begin
      for i := 1 to NumAddHyConData do
      begin
        Rectangle(-3 + Glmargin + Trunc((Wkm[i] - GXmin)/(GXmax - GXmin) * Gwidth), -3 + Gtmargin + Gheight - Trunc((LogKm[i] - GYmin)/(GYmax - GYmin) * Gheight),
                  +3 + Glmargin + Trunc((Wkm[i] - GXmin)/(GXmax - GXmin) * Gwidth), +3 + Gtmargin + Gheight - Trunc((LogKm[i] - GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    Pen.Color:= cl3DLight;
  end;
end;
//----------------------------------------------------------
procedure TMain.SetDefaultFont;
begin
  with HyperText.TargetCanvas.Font do
  begin
    Assign(Self.Font);
    Size := Trunc(StdFontSize * Vadjuster);
    Style:= [];
    HyperText.Shadow:= False;
    Color:= clBlack;
  end;
end;

procedure TMain.Report;
var
  i, j: Integer;
  S2, S3, S4: String;
  y: array[0..20] of Integer;
begin
  HyperText.TargetCanvas:= image1.Canvas;
  with image1.Canvas do
  begin
    Brush.Color:= clWindow; //cl3DLight;
    Brush.Style:= bsSolid;
    Pen.Color  := clWindow; //cl3DLight;
//    Rectangle(0, 0, imgReport.Width, imgReport.Height);
    Pen.Color:= cl3DLight;
    Pen.Color := clBlack;
    Font.Color:= clBlack;
    Font.Size := Trunc(StdFontSize * Vadjuster);
    for i := 0 to 20 do
      y[i]:= 5 + Ceil(i * 1.6 * StdFontSize); // * adjuster);
    if Mode <> 2 then
    begin
      case t_unit of
      1    :dumstr:='sec';
      60   :dumstr:='min';
      3600 :dumstr:='hour';
      86400:dumstr:='day';
      end;
      SetDefaultFont;
      IniDay := StartDate + tin_a_day_ini * 3600 / t_unit / 24;
      TextOut(3, 5,'Time = '+  ' ' + FormatFloat('########0.000', time_) + dumstr + ' ' + DateToStr(IniDay + DayCounter) + ' ' + FormatDateTime('hh:mm', time_in_a_day * t_unit / 86400));
      if (time_ > 0) and (navdt > 0) then
        TextOut(3,y[1], Msg[20] + FormatFloat('########0.00####', RoundToDecimalSF(avdt/navdt, 3)) + dumstr);
      i := 2;
      TextOut(3, y[2], Msg[21]);
      TextOut(j, y[2], '= '+ FormatFloat('0.0000', W[1]));
      if solute then
      begin
        i := i + 1;
        //TextOut(3, y[i], );
        dumstr:= ' = '+ FormatFloat('##0.00', C[1]) + 'mg/cm[^]3[-]';
        // TextOut(140, y[i], '= '+ FormatFloat('##0.00',C[1])+'mg/cm3');
        HyperText.Write(Msg[22] + dumstr, 3, y[i], 0);
        SetDefaultFont
      end;
      if heat then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[23]);
        TextOut(j, y[i], ' = '+ FormatFloat('#0.0',T[1]-273.2) + 'C');
      end;
      i := i + 1;
      TextOut(3, y[i], Msg[24] + FormatFloat('#0.000', 100 * WCumRError) + '%');
      i := i + 1;
      TextOut(3, y[i], Msg[25] + FormatFloat('#0.000', Hpond) + 'cm');
      if solute then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[26] + FormatFloat('#0.000', 100 * SCumRError) + '%');
      end;
      if heat then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[27] + FormatFloat('#0.000', 100 * ECumRError) + '%');
      end;
      if Mode = 3 then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[34] + FormatFloat('#0.000', ql_top * (t_ql_top[2] - t_ql_top[1])) + 'cm');
      end;
   //   if time_ >= t_end then
      begin
        if heat then
        begin
          i := i + 1;
          TextOut(3, y[i], Msg[29] + FormatFloat('#0.0', CumEvap) + ' cm');
          i := i + 1;
          TextOut(3, y[i], Msg[30] + FormatFloat('#0.0', CumTr) + ' cm');
          i := i + 1;
          TextOut(3, y[i], Msg[31] + FormatFloat('#0.0', CumInfilt) + ' cm');
          i := i + 1;
          IrgCapacity := 0;
          for j := 1 to n do
             IrgCapacity := IrgCapacity + (Wfc - W[i]) * dz[i];
          TextOut(3, y[i], Msg[32] + FormatFloat('#0.000', IrgCapacity) + ' cm');
          if CumTrp > 0 then
          begin
            i := i + 1;
            TextOut(3, y[i], Msg[33] + FormatFloat('0.00', CumTr / CumTrp));
            if Vreservoir_max > 0 then
            begin
              i := i + 1;
              TextOut(3, y[i], Msg[35] + FormatFloat('#0.00', Vreservoir));
            end;
          end;
        end;
      end;
      if NegativeDCwarning = 1 then
      begin
       // Font.Name:= 'Arial Narrow';
        Font.Size:= Trunc(0.93 * StdFontSize * Vadjuster);
        Font.Color:= clRed;
        TextOut(0,y[8],'[ WARNING ]');
        TextOut(0,y[9],'Negative corrected-dispersion coefficient was induced!');
        TextOut(0,y[10],'Smaller space increment is recommended.');
      end;
    end
    else
    begin
      i := -1;
      if StdFontSize > 10 then
      begin
        S4:= '[4]';
        S3:= '[3]';
        S2:= '[2]';
      end
      else
      begin
        S4:= '[3]';
        S3:= '[2]';
        S2:= '[1]';
      end;
      if Water then
      begin
        if IPET_type = 8 then
        begin
          i := i + 1;
          dumstr:=  S4 + '[i][r]k[_]mb[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.000000', HC_mb);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
          i := i + 1;
          dumstr:=  S4 + '[i]ψ[_][r]mba[-]' + S3 + '[a][ ] = ' + FormatFloat('##0.0', AEVmembrane);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
          i := i + 1;
          dumstr:=  S4 + '[i][r]ω[_][-]' + S3 + '[a][ ] = ' + FormatFloat('0.0', ExponentMembrane);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
        end
        else
        begin
          if KsatFix <> 1 then
          begin
            i := i + 1;
            dumstr:=  S4 + '[i][r]K[_]sat[-]' + S3 + '[a][ ] = ' + FormatFloat('0.######', Soil.Ksat[1]) + ' cm/s';
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
          end;
          if (FitMode = 1) or (independent = 1) or (IPET_type = 5) or (IPET_type = 7) then
          begin
            i := i + 1;
            dumstr:=  S4 + '[i][r]a[_]k[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.000', Soil.ak[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
            i := i + 1;
            dumstr:=  S4 + '[i][r]b[_]k[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.000', Soil.bk[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
            if (Soil.KF[1] = 1) or (Soil.KF[1] = 4) then
            begin
              i := i + 1;
              dumstr:=  S4 + '[i][r]c[_]k[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.000', Soil.ck[1]);
              HyperText.Write(dumstr, 3, y[i], 0);
              SetDefaultFont;
            end;
          end
          else
          begin
            if akFix <> 1 then
            begin
              i := i + 1;
              dumstr:=  S4 + '[i][r]a[_][_]k[-][a]' + S3 + '[ ] = ' + FormatFloat('0.000', Soil.ak[1]);
              HyperText.Write(dumstr, 3, y[i], 0);
              SetDefaultFont;
            end;
            if bkFix <> 1 then
            begin
              i := i + 1;
              dumstr:=  S4 + '[i][r]b[_][_]k[-][a]' + S3 + '[ ] = ' + FormatFloat('0.000', Soil.bk[1]);
              HyperText.Write(dumstr, 3, y[i], 0);
              SetDefaultFont;
            end;
            if WsatFix <> 1 then
            begin
              i := i + 1;
              dumstr:=  S3 + '[r]θ' + S4 + '[i][_] sat[-]' + S3 + '[ ][a] = ' + FormatFloat('0.######', Soil.Wsat[1]);
              HyperText.Write(dumstr, 3, y[i], 0);
              SetDefaultFont;
            end;
            i := i + 1;
            dumstr:=  S3 + 'α[a][_]1[-]' + S3 + ' = ' + FormatFloat('0.000', Soil.alpha1[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
            i := i + 1;
            dumstr:=  S4 + '[r][i]n[a]' + S3 + '[ ][_][_][_]1[-]' + S3 + ' = ' + FormatFloat('0.000', Soil.np1[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
            if WrFix <> 1 then
            begin
              i := i + 1;
              dumstr:=  S3 + '[r]θ' + S3 + '[_][i] r[a][-][ ]' + S3 + ' = ' + FormatFloat('0.######', Soil.Wr[1]);
              HyperText.Write(dumstr, 3, y[i], 0);
              SetDefaultFont;
            end;
          end;
        end;
      end
      else
      begin
        i := i + 1;
        dumstr:=  S4 + 'λ[~][~][a]' + S3 + '[ ] = ' + FormatFloat('0.000', Soil.dispersivity[1]);
        HyperText.Write(dumstr, 3, y[i], 0);
        SetDefaultFont;
      end;
      i := i + 1;
      if Water then
        TextOut(3, y[i] + 4, Msg[24] + FormatFloat('#0.000', 100 * WCumRError) + '%')
      else
        TextOut(3, y[i] + 4, Msg[26] + FormatFloat('#0.000', 100 * SCumRError) + '%');
      ColumnPosition:= i;
    end;
  end;
end;
//===============================================================================================================================
procedure TMain.AnimatedFigure1Click(Sender: TObject);
begin
  ShowResult.PrepareAnime;
end;
//----------------------------------------------------------
procedure TMain.Play_or_StopClick(Sender: TObject);
begin
  ShowResult.Play_or_StopClick;
end;
//----------------------------------------------------------
procedure TMain.SlowClick(Sender: TObject);
begin
  ShowResult.Timer1.Interval:= ShowResult.Timer1.Interval * 2
end;
//----------------------------------------------------------
procedure TMain.RewindClick(Sender: TObject);
begin
  ShowResult.RewindClick;
end;
//----------------------------------------------------------
procedure TMain.FastForwardClick(Sender: TObject);
begin
  ShowResult.FastForwardClick;
end;
//----------------------------------------------------------
procedure TMain.tbSaveProfileClick(Sender: TObject);
begin
  ShowResult.tbSaveProfileClick;
end;
//----------------------------------------------------------
procedure TMain.tbStepForwardClick(Sender: TObject);
begin
  ShowResult.StepForward(Sender);
end;
//----------------------------------------------------------
procedure TMain.tbStepBackwardClick(Sender: TObject);
begin
  ShowResult.StepBackward(Sender);
end;
//===============================================================================================================================
procedure TMain.Language;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
begin
  Msg[1]:= 'The information file has been modified. Do you want to save current informations?';
  Msg[2]:= 'If you want to abort the simulation, press [Esc] key.';
  Msg[3]:= 'Do you want to hold files for animation?';
  Msg[4]:= 'Files for animation occupy several MB.';
  Msg[5]:= 'File already exists, overwrite?';
  Msg[6]:= 'Demo file can not be overwritten. Please save with another name.';
  Msg[7]:= 'Volumetric water content';
  Msg[8]:= 'Solute concentration(mg/cm[^]3[-])';
  Msg[9]:= 'Temperature(C)';
  Msg[10]:= 'Pressure head(cm)';
  Msg[11]:= 'z';
  Msg[12]:= 'Water flux (mm/d, positive upward)';
  Msg[13]:= 'Water vapor';
  Msg[14]:= 'Liquid water';
  Msg[15]:= 'Evaporation rate';
  Msg[16]:= 'Liquid flux at the top    ';
  Msg[17]:= 'Liquid flux at the bottom ';
  Msg[18]:= 'Time(day)';
  Msg[19]:= 'Time(hour)';
  Msg[20]:= 'current average time increment = ';
  Msg[21]:= 'θ at the top';
  Msg[22]:= 'concentration at the top  ';
  Msg[23]:= 'temperature at the top    ';
  Msg[24]:= 'cumul. relative error for water  = ';
  Msg[25]:= 'ponding depth = ';
  Msg[26]:= 'cumul. relative error for solute = ';
  Msg[27]:= 'cumul. relative error for heat   = ';
  Msg[28]:= 'cumulatively relative error for water  = ';
  Msg[29]:= 'cumul. evaporation in the duration = ';
  Msg[30]:= 'cumul. transpiration in the duration = ';
  Msg[31]:= 'cumul. infilt. in the duration = ';
  Msg[32]:= 'capacity for irrigation = ';
  Msg[33]:= 'cumulative (Tr / Trp) = ';
  Msg[34]:= 'irrigation amount = ';
  Msg[35]:= 'storage in the reservoir = ';

  S:= Self.Name;
  ResourceFileName:= ChangeFileExt(Application.ExeName, '.lng');
  if FileExists(ResourceFileName) then
  begin
    IniFile:= TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        File1.Caption           := ReadString(S, 'File1.Caption', '');
        Open1.Caption           := ReadString(S, 'Open1.Caption', '');
        SaveAs1.Caption         := ReadString(S, 'SaveAs1.Caption', '');
        Print1.Caption          := ReadString(S, 'Print1.Caption', '');
        Exit1.Caption           := ReadString(S, 'Exit1.Caption', '');
        Input1.Caption          := ReadString(S, 'Input1.Caption', '');
        IG.Caption              := ReadString(S, 'IG.Caption', '');
        II.Caption              := ReadString(S, 'II.Caption', '');
        IP.Caption              := ReadString(S, 'IP.Caption', '');
        ISP.Caption             := ReadString(S, 'ISP.Caption', '');
        ISR.Caption             := ReadString(S, 'ISR.Caption', '');
        ISK.Caption             := ReadString(S, 'ISK.Caption', '');
        ISS.Caption             := ReadString(S, 'ISS.Caption', '');
        ISH.Caption             := ReadString(S, 'ISH.Caption', '');
        ISE.Caption             := ReadString(S, 'ISE.Caption', '');
        IW.Caption              := ReadString(S, 'IW.Caption', '');
        IA.Caption              := ReadString(S, 'IA.Caption', '');
        ISM.Caption             := ReadString(S, 'ISM.Caption', '');
        Execute1.Caption        := ReadString(S, 'Execute1.Caption', '');
        Output.Caption          := ReadString(S, 'Output.Caption', '');
        ConvertToRate.Caption   := ReadString(S, 'ConvertToRate.Caption', '');
        AnimatedFigure1.Caption := ReadString(S, 'AnimatedFigure1.Caption', '');
        PlayorStop2.Caption     := ReadString(S, 'PlayorStop2.Caption', '');
        Slow2.Caption           := ReadString(S, 'Slow2.Caption', '');
        FastForward2.Caption    := ReadString(S, 'FastForward2.Caption', '');
        Rewind2.Caption         := ReadString(S, 'Rewind2.Caption', '');
        ShowObservationFigure.Caption:= ReadString(S, 'ShowObservationFigure.Caption', '');
        ShowProfileFigure.Caption:= ReadString(S, 'ShowProfileFigure.Caption', '');
        Help1.Caption           := ReadString(S, 'Help1.Caption', '');
        Contents1.Caption       := ReadString(S, 'Contents1.Caption', '');
        About1.Caption          := ReadString(S, 'About1.Caption', '');
        ToolButton1.Hint        := ReadString(S, 'ToolButton1.Hint', '');
        ToolButton2.Hint        := ReadString(S, 'ToolButton2.Hint', '');
        ToolButton3.Hint        := ReadString(S, 'ToolButton3.Hint', '');
        ToolButton4.Hint        := ReadString(S, 'ToolButton4.Hint', '');
        tbSaveProfile.Hint      := ReadString(S, 'tbSaveProfile.Hint', '');
        for i := 1 to 40 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        IniFile.Free;
      end;
    end;
end;

//----------------------------------------------------------
procedure TMain.Contents1Click(Sender: TObject);
begin
  HelpSearch.TabControl.TabIndex:= 0;
  Application.ProcessMessages;
  HelpSearch.Show;
end;
//----------------------------------------------------------
procedure TMain.ShowObservationFigureClick(Sender: TObject);
begin
  case IPET_type of
  1: ExecuteXYGrapher(7);
  2: ExecuteXYGrapher(1);
  3: ExecuteXYGrapher(2);
  4: ExecuteXYGrapher(9);
  5: ExecuteXYGrapher(3);
  end;
end;

procedure TMain.ShowProfileFigureClick(Sender: TObject);
begin
  ExecuteXYGrapher(8);
end;
//----------------------------------------------------------
procedure TMain.ExecuteXYGrapher(XYGrapherMode: Integer; Layer: Integer = 1);
begin
  with ShowResult do
    Case XYGrapherMode of
     1:SetProperty_of_MSO_ObservationFigure(CaseName + '_Outflow&Pressure');
     2:SetProperty_of_MSI_ObservationFigure(CaseName + '_Inflow');
     3:SetProperty_of_UIM_ObservationFigure(CaseName + '_Inflow');
     4:SetProperty_of_TherConCurve(Layer, CaseName + '_THC_Curve');
     5:SetProperty_of_AlbedoCurve(Layer, CaseName + '_AlbedoCurve');
     6:SetProperty_of_EnCurve(Layer, CaseName + '_Enhance_Curve');
     7:SetProperty_of_TSM_ObservationFigure(CaseName + '_observation');
     8:SetProperty_of_ProfileFigure(CaseName + '_profile');
     9:SetProperty_of_EM_ObservationFigure(CaseName + '_observation');
    10:SetProperty_of_ReductionFunction(CaseName + '_reduction_function');
    11:SetProperty_of_RootDensityDistribution(CaseName + '_root_density_distribution');
    12:SetProperty_of_RootDepth_and_LAI(CaseName + '_root_depth&LAI');
    13:SetProperty_of_CropCoefficient(CaseName + '_crop_coefficient');
    end;
 //   ShowResult.Release;
end;

procedure TMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case Key of
  27 : StopCalc:= 1; //ESC
  113: if Graph = 1 then Graph:= 0 else Graph:= 1;//F2
  end;
end;

procedure TMain.AnimeCounterDblClick(Sender: TObject);
begin
  if Demonstration = False then
  begin
    ShowMessage('Demonstration mode on.');
    Demonstration:= True
  end
  else
  begin
    ShowMessage('Demonstration mode off.');
    Demonstration:= False;
  end;
end;

procedure TMain.SendDataToSoil;
var i: Integer;
begin
  Soil.Modified:= Modified;
  Soil.Mode:= Mode;
  Soil.CaseName:= CaseName;
  Soil.BaseDir:= BaseDir;
  Soil.NumLayer:= NumLayer;
  Soil.WsatFix:= WsatFix;
  Soil.WrFix:= WrFix;
  Soil.LlambdaFix:= LlambdaFix;
  Soil.spFix:= spFix;
  Soil.ZetaFix:= ZetaFix;
  Soil.Linked_m:= Linked_m;
  Soil.heat:= heat;
  Soil.fl_retention:= fl_retention;
  Soil.IPET_type:= IPET_type;
  Soil.Independent:= Independent;
  Soil.t_unit:= t_unit;
  for i := 1 to NumLayer do
    Soil.SoilName[i]:= SoilName[i];
end;

procedure TMain.RetrieveDataFromSoil;
var i: Integer;
begin
  GoAhead:= Soil.GoAhead;
  dialogbox:= Soil.dialogbox;
  WsatFix:= Soil.WsatFix;
  WrFix:= Soil.WrFix;
  LlambdaFix:= Soil.LlambdaFix;
  spFix:= Soil.spFix;
  ZetaFix:= Soil.ZetaFix;
  Linked_m:= Soil.Linked_m;
  for i := 1 to NumLayer do
    SoilName[i]:= Soil.SoilName[i];
end;

procedure TMain.SendDataToKparams;
begin
  Kparams.t_unit:= t_unit;
  Kparams.FitMode:= FitMode;
  Kparams.KsatFix:= KsatFix;
  Kparams.akFix:= akFix;
  Kparams.bkFix:= bkFix;
end;

procedure TMain.RetrieveDataFromKparams;
begin
  GoAhead:= Kparams.GoAhead;
  KsatFix:= Kparams.KsatFix;
  akFix  := Kparams.akFix;
  bkFix  := Kparams.bkFix;
  dialogbox:= Kparams.dialogbox;
end;

function TMain.GetRelativeDirectory(Origin, S: String): String;
var
  S0, S1: String;
begin
 // Result := ExtractRelativePath(Origin, S);
  if S <> '' then
  begin
    if Pos(AnsiLowerCase(Origin), AnsiLowerCase(S)) > 0 then
      Result := StringReplace(S, Origin + Slash, '', [rfIgnoreCase])
    else
    begin
      S  := StringReplace(S, '..' + Slash, '', [rfReplaceAll]);
      S0 := '';
      S1 := Origin;
      repeat
        S0 := S0 + '..' + Slash;
        S1 := ExtractFileDir(S1);
      until (Pos(AnsiLowerCase(S1), AnsiLowerCase(S)) > 0) or ((Length(S1) = 3) and (Pos(':', S1) > 0));
      if ((Length(S1) = 3) and (Pos(':', S1) > 0)) then
        if S[1] <> Origin[1] then
          S0 := S0 + '..' + Slash;
      if S1 = Slash then
        S1 := ''
      else
        if S1[Length(S1)] = Slash then
          S1 := Copy(S1, 0, Length(S1)-1);
      if Pos(AnsiLowerCase(S1), AnsiLowerCase(S + Slash)) = 1 then
        S := StringReplace(S, S1 + Slash, '', [rfIgnoreCase]);
      if Pos(AnsiLowerCase(S1), AnsiLowerCase(S)) = 1 then
        S := StringReplace(S, S1, '', [rfIgnoreCase]);
      Result := S0 + S;
    end;
  end
  else
    Result := '';
end;

function TMain.GetAbsoluteDirectory(Origin, S: String): String;
begin
  if (Pos('..' + Slash, S) = 0) and (Pos(':', S) > 0) then
    Result:= S
  else
  begin
    while Pos('..' + Slash, S) > 0 do
    begin
      if ((Length(Origin) > 3) or (Pos(':', Origin) = 0)) then
        Origin:= ExtractFileDir(Origin)
      else
        Origin:= '';
      S:= StringReplace(S, '..' + Slash, '', []);
    end;
    if Length(Origin) <> 3 then
    begin
      if (Origin <> Slash) and (Origin <> '') then
        Result:= Origin + Slash + S
      else
        Result:= Origin + S;
    end
    else
      Result:= Origin + S;
  end;
end;

procedure TMain.SelectFile(var ObjectFileName: String; var ObjectEdit: TEdit);
begin
  with OpenDialog3 do
  begin
    if InitialDir = '' then
      InitialDir:= BaseDir;
    FileName  := ObjectFileName;
   // if FileName = '' then
    FileName:= 'Please double-click the file above.';
    if Execute = True then
    begin
      ObjectFileName:= FileName;
      InitialDir:= ExtractFileDir(FileName);
    end;
  end;
  ObjectEdit.Text:= Main.GetRelativeDirectory(BaseDir, ObjectFileName);
end;

function TMain.ConvertDecimalSeparator(S: String): String;
begin
  if DecimalSeparator = ',' then
  begin
    //S := StringReplace(S, ',', ' ', [rfReplaceAll]);
    Result := StringReplace(S, '.', ',', [rfReplaceAll]);
  end
  else
  begin
    Result := StringReplace(S, ',', '.', [rfReplaceAll]);
  end
end;

Initialization
{$I WASH1dMain.lrs}
end.



